# FilePathsBase.jl

[![Build Status](https://github.com/rofinn/FilePathsBase.jl/workflows/CI/badge.svg)](https://github.com/rofinn/FilePathsBase.jl/actions)
[![codecov.io](https://codecov.io/github/rofinn/FilePathsBase.jl/coverage.svg?branch=master)](https://codecov.io/rofinn/FilePathsBase.jl?branch=master)
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://rofinn.github.io/FilePathsBase.jl/stable)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://rofinn.github.io/FilePathsBase.jl/dev)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/JuliaDiff/BlueStyle)

FilePathsBase.jl provides a type based approach to working with filesystem paths in julia.

## Intallation

FilePathsBase.jl is registered, so you can to use `Pkg.add` to install it.
```julia
julia> Pkg.add("FilePathsBase")
```

## Getting Started

Here are some common operations that you may want to perform with file paths.

```julia
#=
NOTE: We're loading our `/` operator for path concatenation into the currect scope, but non-path division operations will still fallback to the base behaviour.
=#
julia> using FilePathsBase; using FilePathsBase: /

julia> cwd()
p"/Users/rory/repos/FilePathsBase.jl"

julia> walkpath(cwd() / "docs") |> collect
23-element Array{Any,1}:
 p"/Users/rory/repos/FilePathsBase.jl/docs/.DS_Store"
 p"/Users/rory/repos/FilePathsBase.jl/docs/Manifest.toml"
 p"/Users/rory/repos/FilePathsBase.jl/docs/Project.toml"
 p"/Users/rory/repos/FilePathsBase.jl/docs/build"
 p"/Users/rory/repos/FilePathsBase.jl/docs/build/api.html"
 p"/Users/rory/repos/FilePathsBase.jl/docs/build/assets"
 p"/Users/rory/repos/FilePathsBase.jl/docs/build/assets/arrow.svg"
 p"/Users/rory/repos/FilePathsBase.jl/docs/build/assets/documenter.css"
 ...

julia> stat(p"docs/src/index.md")
Status(
  device = 16777223,
  inode = 32240108,
  mode = -rw-r--r--,
  nlink = 1,
  uid = 501 (rory),
  gid = 20 (staff),
  rdev = 0,
  size = 2028 (2.0K),
  blksize = 4096 (4.0K),
  blocks = 8,
  mtime = 2020-04-20T17:20:38.612,
  ctime = 2020-04-20T17:20:38.612,
)

julia> relative(p"docs/src/index.md", p"src/")
p"../docs/src/index.md"

julia> normalize(p"src/../docs/src/index.md")
p"docs/src/index.md"

julia> absolute(p"docs/src/index.md")
p"/Users/rory/repos/FilePathsBase.jl/docs/src/index.md"

julia> islink(p"docs/src/index.md")
true

julia> canonicalize(p"docs/src/index.md")
p"/Users/rory/repos/FilePathsBase.jl/README.md"

julia> parents(p"./docs/src")
2-element Array{PosixPath,1}:
 p"."
 p"./docs"

julia> parents(absolute(p"./docs/src"))
6-element Array{PosixPath,1}:
 p"/"
 p"/Users"
 p"/Users/rory"
 p"/Users/rory/repos"
 p"/Users/rory/repos/FilePathsBase.jl"
 p"/Users/rory/repos/FilePathsBase.jl/docs"

julia> absolute(p"./docs/src")[1:end-1]
("Users", "rory", "repos", "FilePathsBase.jl", "docs")

julia> tmpfp = mktempdir(SystemPath)
p"/var/folders/vz/zx_0gsp9291dhv049t_nx37r0000gn/T/jl_1GCBFT"

julia> sync(p"/Users/rory/repos/FilePathsBase.jl/docs", tmpfp / "docs")
p"/var/folders/vz/zx_0gsp9291dhv049t_nx37r0000gn/T/jl_1GCBFT/docs"

julia> exists(tmpfp / "docs" / "make.jl")
true

julia> m = mode(tmpfp / "docs" / "make.jl")
Mode("-rw-r--r--")

julia> m - readable(:ALL)
Mode("--w-------")

julia> m + executable(:ALL)
Mode("-rwxr-xr-x")

julia> chmod(tmpfp / "docs" / "make.jl", "+x")
"/var/folders/vz/zx_0gsp9291dhv049t_nx37r0000gn/T/jl_1GCBFT/docs/make.jl"

julia> mode(tmpfp / "docs" / "make.jl")
Mode("-rwxr-xr-x")

# Count LOC
julia> mapreduce(+, walkpath(cwd() / "src")) do x
           extension(x) == "jl" ? count("\n", read(x, String)) : 0
       end
3020

# Concatenate multiple files.
julia> str = mapreduce(*, walkpath(tmpfp / "docs" / "src")) do x
           read(x, String)
       end
"# API\n\nAll the standard methods for working with paths in base julia exist in the FilePathsBase.jl. The following describes the rough mapping of method names. Use `?` at the REPL to get the documentation and arguments as they may be different than the base implementations.\n\n..."

# Could also write the result to a file with `write(newfile, str)`)

julia> rm(tmpfp; recursive=true)

julia> exists(tmpfp)
false

# Loading code from paths (e.g., S3Path)
julia> FilePathsBase.@__INCLUDE__()

julia> include(p"test/testpkg.jl")
Main.TestPkg
```

"""
    WindowsPath()
    WindowsPath(str)

Represents a windows path (e.g., `C:\\User\\Documents`)
"""
struct WindowsPath <: SystemPath
    segments::Tuple{Vararg{String}}
    root::String
    drive::String
    separator::String

    function WindowsPath(
        segments::Tuple, root::String, drive::String, separator::String=WIN_PATH_SEPARATOR
    )
        return new(Tuple(Iterators.filter(!isempty, segments)), root, drive, separator)
    end
end

function _win_splitdrive(fp::String)
    m = match(
        r"^([^\\]+:|\\\\[^\\]+\\[^\\]+|\\\\\?\\UNC\\[^\\]+\\[^\\]+|\\\\\?\\[^\\]+:|)(.*)$",
        fp,
    )
    return String(m.captures[1]), String(m.captures[2])
end

WindowsPath() = WindowsPath(tuple(), "", "")

function WindowsPath(segments::Tuple; root="", drive="", separator="\\")
    return WindowsPath(segments, root, drive, separator)
end

function Base.tryparse(::Type{WindowsPath}, str::AbstractString)
    isempty(str) && WindowsPath(tuple("."), "", "")

    if startswith(str, "\\\\?\\")
        @debug("The \\\\?\\ prefix is currently not supported.")
        return nothing
    end

    str = replace(str, POSIX_PATH_SEPARATOR => WIN_PATH_SEPARATOR)

    if startswith(str, "\\\\")
        @debug("UNC paths are currently not supported.")
        return nothing
    elseif startswith(str, "\\")
        tokenized = split(str, WIN_PATH_SEPARATOR)

        return WindowsPath(tuple(String.(tokenized[2:end])...), WIN_PATH_SEPARATOR, "")
    elseif occursin(":", str)
        l_drive, l_path = _win_splitdrive(str)

        tokenized = split(l_path, WIN_PATH_SEPARATOR)

        l_root = isempty(tokenized[1]) ? WIN_PATH_SEPARATOR : ""

        if isempty(tokenized[1])
            tokenized = tokenized[2:end]
        end

        if !isempty(l_drive) || !isempty(l_root)
            tokenized = tuple(tokenized...)
        end

        return WindowsPath(tuple(String.(tokenized)...), l_root, l_drive)
    else
        tokenized = split(str, WIN_PATH_SEPARATOR)

        return WindowsPath(tuple(String.(tokenized)...), "", "")
    end
end

function Base.:(==)(a::WindowsPath, b::WindowsPath)
    return lowercase.(a.segments) == lowercase.(b.segments) &&
           lowercase(a.root) == lowercase(b.root) &&
           lowercase(a.drive) == lowercase(b.drive)
end

function Base.show(io::IO, fp::WindowsPath)
    print(io, "p\"")
    if isabsolute(fp)
        print(io, replace(fp.anchor, "\\" => "/"))
    end
    print(io, join(fp.segments, "/"))
    return print(io, "\"")
end

isabsolute(fp::WindowsPath) = (!isempty(fp.drive) || !isempty(fp.root))

ps = PathSet(; symlink=true)

@testset "$(typeof(ps.root))" begin
    testsets = [
        test_registration,
        test_show,
        test_cmd,
        test_parse,
        test_convert,
        test_components,
        test_indexing,
        test_iteration,
        test_parents,
        test_descendants_and_ascendants,
        test_join,
        test_splitext,
        test_basename,
        test_splitdir,
        test_filename,
        test_extensions,
        test_isempty,
        test_normalize,
        test_canonicalize,
        test_relative,
        test_absolute,
        test_isdir,
        test_isfile,
        test_stat,
        test_filesize,
        test_modified,
        test_created,
        test_cd,
        test_readpath,
        test_walkpath,
        test_read,
        test_write,
        test_mkdir,
        test_cp,
        test_mv,
        test_sync,
        test_symlink,
        test_touch,
        test_tmpname,
        test_tmpdir,
        test_mktmp,
        test_mktmpdir,
        test_download,
        test_include,
    ]

    if isa(ps.root, PosixPath)
        append!(
            testsets,
            [
                test_issocket,
                test_isfifo,
                test_ischardev,
                test_isblockdev,
                test_ismount,
                test_isexecutable,
                test_isreadable,
                test_iswritable,
                test_chown,
                test_chmod,
            ],
        )
    end

    # Run all of the automated tests
    test(ps, testsets)

    # Test the system path specific macros, behaviour and properties
    cd(absolute(parent(Path(@__FILE__)))) do
        @testset "Simple System Path Usage" begin
            reg = Sys.iswindows() ? "..\\src\\FilePathsBase.jl" : "../src/FilePathsBase.jl"
            @test ispath(reg)

            p = Path(reg)

            # Test calling the Path tryparse method with debug mode.
            p = tryparse(AbstractPath, reg; debug=true)

            @test p == p"../src/FilePathsBase.jl"
            @test string(p) == reg
            @test string(cwd()) == pwd()
            @test string(home()) == homedir()

            @test p.segments == ("..", "src", "FilePathsBase.jl")
            @test hasparent(p)
            @test parent(p) == p"../src"
            @test parents(p) == [p"..", p"../src"]
            @test parents(p".") == [p"."]

            @test basename(p) == "FilePathsBase.jl"
            @test join(parent(p), Path(basename(p))) == p
            @test joinpath(parent(p), Path(basename(p))) == p
            @test parent(p) / basename(p) == p
            @test parent(p) * "/" * basename(p) == p
            @test p"foo" / "bar" * ".txt" == p"foo/bar.txt"
            @test filename(p) == "FilePathsBase"

            @test extension(p) == "jl"
            @test extension(p"../REQUIRE") == ""
            @test extensions(p"foo.tar.gz") == ["tar", "gz"]
            @test length(extensions(p"../REQUIRE")) == 0

            @test exists(p)
            @test !isabsolute(p)
            @test string(normalize(p"../src/../src/FilePathsBase.jl")) ==
                normpath("../src/../src/FilePathsBase.jl")
            @test string(absolute(p)) == abspath(string(p))
            @test sprint(show, p"../README.md") == "p\"../README.md\""

            # This works around an issue with Base.relpath: that function does not take
            # into account the paths on Windows should be compared case insensitive.
            homedir_patched = homedir()
            if Sys.iswindows()
                conv_f = isuppercase(abspath(string(p))[1]) ? uppercase : lowercase
                homedir_patched = conv_f(homedir_patched[1]) * homedir_patched[2:end]
            elseif Sys.isunix()
                contracted_path = p"~/opt/foo/bar.jl"
                expanded_path = joinpath(home(), "opt/foo/bar.jl")
                @test expanduser(contracted_path) == expanded_path
                @test contractuser(expanded_path) == contracted_path

                # relpath isn't entirely consistent for windows on julia 1.5
                # https://github.com/rofinn/FilePathsBase.jl/issues/107
                @test string(relative(p, home())) == relpath(string(p), homedir_patched)
            end

            @test isa(relative(Path(".")), AbstractPath)
            @test relative(Path(".")) == Path(".")

            @test canonicalize(p"../test/mode.jl") == Path(realpath("../test/mode.jl"))

            s = stat(p)
            lstat(p)

            show_str = sprint(show, s)
            #@test "device" in show_str
            #@test "blocks" in show_str

            @test filesize(p) == stat(p).size
            @test modified(p) == stat(p).mtime
            @test created(p) == stat(p).ctime

            @test isfile(p)
            @test isdir(parent(p))
            @test !islink(p)
            @test !issocket(p)
            @test !isfifo(p)
            @test !ischardev(p)
            @test !isblockdev(p)

            p1 = WindowsPath(("foo", "bar"))
            @test p1.segments == ("foo", "bar")
            @test p1.drive == ""
            @test p1.root == ""

            p2 = WindowsPath(("foo", "bar"); root="\\", drive="C:")
            @test p2.segments == ("foo", "bar")
            @test p2.drive == "C:"
            @test p2.root == "\\"

            p3 = WindowsPath(("foo", "bar"); drive="C:")
            @test p3.segments == ("foo", "bar")
            @test p3.drive == "C:"
            @test p3.root == ""

            p4 = WindowsPath("C:\\User\\Documents")
            @test p4.segments == ("User", "Documents")
            @test p4.drive == "C:"
            @test p4.root == "\\"

            @test @__PATH__() == Path(@__DIR__)
            @test @__FILEPATH__() == Path(@__FILE__)
            @test FilePathsBase.@LOCAL("foo.txt") == join(@__PATH__, "foo.txt")
            @test FilePathsBase.@LOCAL("foo.txt") == joinpath(@__PATH__, "foo.txt")
        end

        # Just to be safe we're going to ensure that all Filesystem aliases have the
        # same behaviour, apart from different return types.
        # NOTE: These tests aren't part of the TestPaths test suite because we explicitly want
        # to compare behaviour of the `SystemPath`s again what `Base.Filesystem` does.
        @testset "Filesystem Aliases" begin
            @testset "joinpath" begin
                # Test general usage
                segments = ("..", "src", "FilePathsBase.jl")
                res = joinpath(cwd(), segments...)
                @test res isa SystemPath
                @test string(res) == joinpath(pwd(), segments...)

                # Test trailing absolute path.
                segments = (segments..., pwd())
                res = joinpath(cwd(), segments...)
                @test string(res) == joinpath(pwd(), segments...)
            end

            @testset "basename" begin
                @test basename(p"../src/FilePathsBase.jl") ==
                    basename("../src/FilePathsBase.jl")
            end

            @testset "splitext" begin
                fp = p"../src/FilePathsBase.jl"
                pathname, ext = splitext(fp)
                @test pathname isa SystemPath
                @test ext isa AbstractString
                @test (string(pathname), ext) == splitext(string(fp))
            end

            @testset "ispath" begin
                fp = joinpath(cwd(), "..", "src", "FilePathsBase.jl")
                @test ispath(fp)
                @test ispath(string(fp))
            end

            @testset "normpath" begin
                fp = joinpath(cwd(), "..", "src", "FilePathsBase.jl")
                res = normpath(fp)
                @test res isa SystemPath
                @test string(res) == normpath(string(fp))
            end

            @testset "relpath" begin
                rel_str = joinpath("..", "src", "FilePathsBase.jl")
                rel_fp = Path(rel_str)
                @test relpath(abspath(rel_str)) == rel_str
                @test string(relpath(absolute(rel_fp))) == rel_str

                # Test the 2 argument form
                @test relpath(abspath(rel_str), pwd()) == rel_str
                @test string(relpath(absolute(rel_fp), cwd())) == rel_str

                # Test src as file
                res_str = joinpath("..", "..", "src", "FilePathsBase.jl")
                src_str = joinpath(pwd(), "system.jl")
                src_fp = Path(src_str)
                @test relpath(abspath(rel_str), src_str) == res_str
                @test string(relpath(absolute(rel_fp), src_fp)) == res_str
            end

            @testset "abspath" begin
                fp = joinpath("..", "docs", "src", "index.md")
                res = abspath(Path(fp))
                @test res isa SystemPath
                @test string(res) == abspath(fp)
            end

            @testset "realpath" begin
                # index.md is a symlink to README.md
                fp = joinpath(cwd(), "..", "docs", "src", "index.md")
                res = realpath(fp)
                @test res isa SystemPath
                @test string(res) == realpath(string(fp))
            end

            @testset "stat" begin
                function compare_stats(sp, ss)
                    @test sp isa FilePathsBase.Status
                    @test ss isa StatStruct

                    @test sp.device == ss.device
                    @test sp.inode == ss.inode
                    @test sp.mode != ss.mode
                    @test sp.mode.m == ss.mode
                    @test sp.nlink == ss.nlink
                    @test sp.user != ss.uid
                    @test sp.user.uid == ss.uid
                    @test sp.group != ss.gid
                    @test sp.group.gid == ss.gid
                    @test sp.rdev == ss.rdev
                    @test sp.size == ss.size
                    @test sp.blksize == ss.blksize
                    @test sp.blocks == ss.blocks
                    @test sp.mtime != ss.mtime
                    @test datetime2unix(sp.mtime) ≈ ss.mtime
                    @test sp.ctime != ss.ctime
                    @test datetime2unix(sp.ctime) ≈ ss.ctime
                end

                fp = joinpath(cwd(), "..", "docs", "src", "index.md")
                compare_stats(stat(fp), stat(string(fp)))
                compare_stats(lstat(fp), lstat(string(fp)))
            end

            @testset "User/Group constructors" begin
                my_user = FilePathsBase.User()
                my_group = FilePathsBase.Group()

                u_int = FilePathsBase.User(UInt(my_user.uid))
                g_int = FilePathsBase.Group(UInt(my_group.gid))

                @test u_int isa FilePathsBase.User
                @test g_int isa FilePathsBase.Group
                @test u_int.uid isa Unsigned
                @test g_int.gid isa Unsigned

                # Non-existent user or group on unix
                if Sys.isunix()
                    u_int = FilePathsBase.User(UInt(9999))
                    g_int = FilePathsBase.Group(UInt(9999))
                    @test u_int isa FilePathsBase.User
                    @test g_int isa FilePathsBase.Group
                    @test u_int.uid == UInt(9999)
                    @test g_int.gid == UInt(9999)
                    @test u_int.name == "NA"
                    @test g_int.name == "NA"
                end
            end
        end

        # We aren't going to do all the `isfifo`, `ischardev`, etc.
        # However, we'll double check a couple of the common ones.
        @testset "isfile" begin
            fp = joinpath(cwd(), "..", "src", "FilePathsBase.jl")
            @test isfile(fp)
            @test isfile(string(fp))

            @test !isfile(cwd())
            @test !isfile(pwd())

            fp = joinpath(cwd(), "..", "docs", "src", "index.md")
            @test isfile(fp)
            @test isfile(string(fp))
        end

        @testset "isdir" begin
            fp = joinpath(cwd(), "..", "src", "FilePathsBase.jl")
            @test !isdir(fp)
            @test !isdir(string(fp))

            @test isdir(cwd())
            @test isdir(pwd())

            fp = joinpath(cwd(), "..", "docs", "src", "index.md")
            @test !isdir(fp)
            @test !isdir(string(fp))
        end

        @testset "islink" begin
            fp = joinpath(cwd(), "..", "src", "FilePathsBase.jl")
            @test !islink(fp)
            @test !islink(string(fp))

            @test !islink(cwd())
            @test !islink(pwd())

            fp = joinpath(cwd(), "..", "docs", "src", "index.md")
            @test islink(fp)
            @test islink(string(fp))
        end

        @testset "isabspath" begin
            fp = joinpath(cwd(), "..", "src", "FilePathsBase.jl")
            @test isabspath(fp)
            @test isabspath(string(fp))

            fp = joinpath("..", "src", "FilePathsBase.jl")
            @test !isabspath(fp)
            @test !isabspath(string(fp))
        end

        @testset "expanduser" begin
            @test expanduser(p"/") == p"/"

            fp = joinpath(cwd(), "..", "src", "FilePathsBase.jl")
            @test string(expanduser(fp)) == expanduser(string(fp))

            fp = joinpath("~", "..", "src", "FilePathsBase.jl")
            @test string(expanduser(fp)) == expanduser(string(fp))
        end

        # Remainder of tests should be run in a tmp dir.
        mktempdir(SystemPath) do fp
            docsdir = joinpath(absolute(parent(parent(Path(@__FILE__)))), "docs")

            cd(fp) do
                @testset "mkdir" begin
                    newdirpath = joinpath(fp, "newdirpath")
                    newdirstr = joinpath(string(fp), "newdirstr")
                    @test mkdir(newdirpath) == newdirpath
                    @test ispath(newdirpath)
                    @test mkdir(newdirstr) == newdirstr
                    @test ispath(newdirstr)
                end

                @testset "mkpath" begin
                    newdirpath = joinpath(fp, "new", "recursive", "dir", "path")
                    newdirstr = joinpath(string(fp), "new", "recursive", "dir", "str")
                    @test mkpath(newdirpath) == newdirpath
                    @test ispath(newdirpath)
                    @test mkpath(newdirstr) == newdirstr
                    @test ispath(newdirstr)

                    # should not throw if path exists
                    @test mkpath(newdirpath) == newdirpath
                    @test mkpath(newdirstr) == newdirstr
                end

                @testset "symlink" begin
                    targetpath = joinpath(fp, "new", "recursive", "dir")
                    targetstr = joinpath(string(fp), "new", "recursive", "dir")
                    @test symlink(targetpath, p"pathlink") == nothing
                    @test ispath(p"pathlink")
                    @test symlink(targetstr, "strlink") == nothing
                    @test ispath("strlink")
                end

                @testset "touch" begin
                    @test touch(p"touchfp") == p"touchfp"
                    @test ispath(p"touchfp")
                    @test touch("touchstr") == "touchstr"
                    @test ispath("touchstr")
                end

                @testset "cp" begin
                    # Single file
                    @test cp(p"touchfp", p"cpfp") == p"cpfp"
                    @test ispath(p"cpfp")
                    @test cp("touchstr", "cpstr") == "cpstr"
                    @test ispath("cpstr")

                    # Recursive directory
                    @test cp(docsdir, p"cpdstpath"; force=true) == p"cpdstpath"
                    @test ispath(p"cpdstpath")
                    @test ispath(p"cpdstpath/src/api.md")
                    @test cp(string(docsdir), "cpdststr"; force=true) == "cpdststr"
                    @test ispath("cpdststr")
                    @test ispath("cpdststr/src/api.md")
                end

                @testset "mv" begin
                    # Single file
                    @test mv(p"cpfp", p"mvfp") == p"mvfp"
                    @test !ispath(p"cpfp")
                    @test ispath(p"mvfp")
                    @test mv("cpstr", "mvstr") == "mvstr"
                    @test ispath("mvstr")

                    # Recursive directory
                    @test mv(p"cpdstpath", p"mvdstpath") == p"mvdstpath"
                    @test ispath(p"mvdstpath")
                    @test ispath(p"mvdstpath/src/api.md")
                    @test !ispath(p"cpdstpath")
                    @test mv("cpdststr", "mvdststr") == "mvdststr"
                    @test ispath("mvdststr")
                    @test ispath("mvdststr/src/api.md")
                    @test !ispath("cpdststr")
                end

                @testset "download" begin
                    url = "https://github.com/rofinn/FilePathsBase.jl/blob/master/README.md"
                    @test download(url, p"README.md") == p"README.md"
                    @test ispath(p"README.md")

                    rm(p"README.md")
                    url = "https://github.com/rofinn/FilePathsBase.jl/blob/master/README.md"
                    @test download(url, "README.md") == "README.md"
                end

                @testset "readdir" begin
                    @test readdir(docsdir) == readdir(string(docsdir))
                end

                @testset "chmod" begin
                    @test chmod(p"touchfp", 0o755) == p"touchfp"
                    @test chmod("touchstr", 0o755) == "touchstr"
                    @test filemode(p"touchfp").m == filemode("touchstr")
                end

                @testset "chown" begin
                    if get(ENV, "USER", "") == "root"
                        @test chown(p"touchfp", -2, -1) == p"touchfp"
                        @test chown("touchstr", -2, -1) == "touchstr"
                        @test stat(p"touchfp").user.uid == stat("touchstr").uid

                        # Non-root user cannot change ownership to another user
                        @test_throws Base.IOError chown(p"touchfp", -2, -1)
                        @test_throws Base.IOError chown("touchstr", -2, -1)

                        # Non-root user cannot change group to a group they are not a member of (eg: nogroup)
                        @test_throws Base.IOError chown(p"touchfp", -1, -2)
                        @test_throws Base.IOError chown("touchstr", -1, -2)
                    end
                end

                @testset "rm" begin
                    @test rm(p"touchfp") == nothing
                    @test !ispath(p"touchfp")
                    @test rm("touchstr") == nothing
                    @test !ispath(p"touchstr")
                end

                @testset "read" begin
                    srcfp = joinpath(docsdir, "src", "api.md")
                    @test read(srcfp, String) == read(string(srcfp), String)
                end

                @testset "write" begin
                    content = read(joinpath(docsdir, "src", "api.md"), String)
                    @test write(p"writefp", content) == write("writestr", content)
                end

                @testset "Mmap.mmap" begin
                    fpmap, strmap = Mmap.mmap(p"README.md"), Mmap.mmap("README.md")
                    @test fpmap == strmap
                    # Ensure that the mmap objects get finalized before we cleanup our working directory.
                    finalize.([fpmap, strmap])
                end
            end
        end
    end
end

@testset "Mode Tests" begin
    m = Mode(; user=(READ + WRITE + EXEC), group=(READ + EXEC), other=EXEC)

    x = executable(:ALL)
    r = readable(:USER, :GROUP)
    w = writable(:USER)

    @test string(m) == "-rwxr-x--x"
    @test string(x) == "---x--x--x"
    @test string(r) == "-r--r-----"
    @test string(w) == "--w-------"

    @test Mode("-rwxr-x--x") == m
    @test Mode("---x--x--x") == x
    @test Mode("-r--r-----") == r
    @test Mode("--w-------") == w
    @test Mode("-rw-r-----") == m - x
    @test Mode("--wx--x--x") == m - r
    @test Mode("-r-xr-x--x") == m - w

    @test FilePathsBase.isexecutable(x, :USER)
    @test FilePathsBase.isexecutable(x, :GROUP)
    @test FilePathsBase.isexecutable(x, :OTHER)
    @test FilePathsBase.isexecutable(x, :ALL)

    @test iswritable(w, :USER)
    @test !iswritable(w, :GROUP)
    @test !iswritable(w, :OTHER)
    @test !iswritable(w, :ALL)

    @test isreadable(r, :USER)
    @test isreadable(r, :GROUP)
    @test !isreadable(r, :OTHER)
    @test !isreadable(r, :ALL)

    @test x + r + w == m

    @test string(m - x) == "-rw-r-----"
    @test string(m - r) == "--wx--x--x"
    @test string(m - w) == "-r-xr-x--x"

    # Since our arbitrary mode
    # only has the permission bits set
    # the following functions should all return false.
    @test !isdir(m)
    @test !isfile(m)
    @test !islink(m)
    @test !issocket(m)
    @test !isfifo(m)
    @test !ischardev(m)
    @test !isblockdev(m)
end

import Base.@deprecate

import Base: real, abs, size

@deprecate real(fp::AbstractPath) canonicalize(fp)
@deprecate abs(fp::AbstractPath) absolute(fp)
@deprecate isabs(fp::AbstractPath) isabsolute(fp)
@deprecate move(src::AbstractPath, dest::AbstractPath; kwargs...) mv(src, dest; kwargs...)
@deprecate remove(fp::AbstractPath; kwargs...) rm(fp; kwargs...)
@deprecate size(fp::AbstractPath) filesize(fp)

using Documenter, FilePathsBase, FilePathsBase.TestPaths

const SETUP_CODE = quote
    using FilePathsBase
    using FilePathsBase: /, join
end

DocMeta.setdocmeta!(FilePathsBase, :DocTestSetup, SETUP_CODE; recursive=true)

makedocs(;
    modules=[FilePathsBase],
    format=Documenter.HTML(; prettyurls=get(ENV, "CI", nothing) == "true"),
    pages=[
        "Home" => "index.md", "Design" => "design.md", "FAQ" => "faq.md", "API" => "api.md"
    ],
    repo="https://github.com/rofinn/FilePathsBase.jl/blob/{commit}{path}#L{line}",
    sitename="FilePathsBase.jl",
    authors="Rory Finnegan",
    # checkdocs = :exports,
    # strict = true,
)

deploydocs(;
    repo="github.com/rofinn/FilePathsBase.jl.git",
    target="build",
    deps=nothing,
    make=nothing,
)

struct Mode
    m::UInt64
end

"""
    Mode(m::UInt8)
    Mode(;user::UInt8=0o0, group::UInt8=0o0, other::UInt8=0o0)
    Mode(mode::UInt8, usr_grps::Symbol...)
    Mode(str)

Provides an abstraction for working with posix file permissions.
A lot of the low level permissions code for this type was below
and the corresponding constants have been translated from
cpython's [Lib/stat.py](https://github.com/python/cpython/blob/master/Lib/stat.py).

# Example
```julia-repl
julia> Mode("-rwxr-x--x")
-rwxr-x--x
```
"""
function Mode(; user::UInt8=0o0, group::UInt8=0o0, other::UInt8=0o0)
    @assert user <= 0o7 && group <= 0o7 && other <= 0o7

    return Mode(user * USER_COEFF | group * GROUP_COEFF | other * OTHER_COEFF)
end

function Mode(mode::UInt8, usr_grps::Symbol...)
    user = group = other = 0o0

    for usr_grp in usr_grps
        if usr_grp == :ALL
            user = group = other = mode
            break
        elseif usr_grp == :USER
            user = mode
        elseif usr_grp == :GROUP
            group = mode
        elseif usr_grp == :OTHER
            other = mode
        else
            throw(
                ArgumentError(
                    "$usr_grp not a valid symbol only " *
                    ":ALL, :USER, :GROUP and :OTHER are accepted.",
                ),
            )
        end
    end

    return Mode(; user=user, group=group, other=other)
end

Mode(s::AbstractString) = parse(Mode, s)

function Base.parse(::Type{Mode}, x::AbstractString)
    n = length(FILEMODE_TABLE)

    if length(x) != n
        throw(
            ArgumentError(
                "Expected a mode permission string with $n characters (e.g., '-rwxrwxrwx')"
            ),
        )
    end

    m = zero(UInt64)
    for i in 1:n
        table = FILEMODE_TABLE[i]
        found = false
        c = x[i]
        c == '-' && continue

        for (bit, char) in table
            if c == char
                m |= bit
                found = true
                break
            end
        end
        if !found
            options = last.(table)
            throw(
                ArgumentError(
                    "Unknown character '$c' at position $i, expected one of $options."
                ),
            )
        end
    end

    return Mode(m)
end

"""Convert a file's mode to a string of the form '-rwxrwxrwx'."""
function Base.print(io::IO, mode::Mode)
    n = length(FILEMODE_TABLE)
    perm = Vector{Char}(undef, n)

    for i in 1:n
        table = FILEMODE_TABLE[i]
        found = false
        for (bit, char) in table
            if mode.m & bit == bit
                perm[i] = char
                found = true
                break
            end
        end
        if !found
            perm[i] = '-'
        end
    end

    return print(io, String(perm))
end

function Base.show(io::IO, mode::Mode)
    return get(io, :compact, false) ? print(io, mode) : print(io, "Mode(\"$mode\")")
end

Base.:-(a::Mode, b::Mode) = Mode(a.m & ~b.m)
Base.:+(a::Mode, b::Mode) = Mode(a.m | b.m)

executable(usr_grps::Symbol...) = Mode(EXEC, usr_grps...)
readable(usr_grps::Symbol...) = Mode(READ, usr_grps...)
writable(usr_grps::Symbol...) = Mode(WRITE, usr_grps...)

function isexecutable(mode::Mode, usr_grp::Symbol)
    mask = S_IXOTH | S_IXGRP | S_IXUSR

    if usr_grp == :OTHER
        mask = S_IXOTH
    elseif usr_grp == :GROUP
        mask = S_IXGRP
    elseif usr_grp == :USER
        mask = S_IXUSR
    end

    return mode.m & mask == mask
end

function Base.iswritable(mode::Mode, usr_grp::Symbol)
    mask = S_IWOTH | S_IWGRP | S_IWUSR

    if usr_grp == :OTHER
        mask = S_IWOTH
    elseif usr_grp == :GROUP
        mask = S_IWGRP
    elseif usr_grp == :USER
        mask = S_IWUSR
    end

    return mode.m & mask == mask
end

function Base.isreadable(mode::Mode, usr_grp::Symbol)
    mask = S_IROTH | S_IRGRP | S_IRUSR

    if usr_grp == :OTHER
        mask = S_IROTH
    elseif usr_grp == :GROUP
        mask = S_IRGRP
    elseif usr_grp == :USER
        mask = S_IRUSR
    end

    return mode.m & mask == mask
end

Base.oct(mode::Mode) = oct(mode.m)
raw(mode::Mode) = mode.m

"""Return True if mode is from a directory."""
Base.isdir(mode::Mode) = _meta(mode.m) == S_IFDIR

"""Return True if mode is from a regular file."""
Base.isfile(mode::Mode) = _meta(mode.m) == S_IFREG

"""Return True if mode is from a symbolic link."""
Base.islink(mode::Mode) = _meta(mode.m) == S_IFLNK

"""Return True if mode is from a socket."""
Base.issocket(mode::Mode) = _meta(mode.m) == S_IFSOCK

"""Return True if mode is from a FIFO (named pipe)."""
Base.isfifo(mode::Mode) = _meta(mode.m) == S_IFIFO

"""Return True if mode is from a character special device file."""
Base.ischardev(mode::Mode) = _meta(mode.m) == S_IFCHR

"""Return True if mode is from a block special device file."""
Base.isblockdev(mode::Mode) = _meta(mode.m) == S_IFBLK

"""
Return the portion of the file's mode that can be set by
os.chmod().
"""
_mode(mode) = mode & 0o7777

"""
Return the portion of the file's mode that describes the
file type.
"""
_meta(mode) = mode & 0o170000

"""
    FileBuffer <: IO

A generic buffer type to provide an IO interface for none IO based path types.

NOTES:
- All `read` operations will read the entire file into the internal buffer at once.
  Subsequent calls to `read` will only operate on the internal buffer and will not access
  the filepath.
- All `write` operations will only write to the internal buffer and `flush`/`close` are
  required to update the filepath contents.
"""
struct FileBuffer <: IO
    path::AbstractPath
    io::IOBuffer
    read::Bool
    write::Bool
    create::Bool
end

function FileBuffer(
    fp::AbstractPath; read=true, write=false, create=false, truncate=false, append=false
)
    buffer = FileBuffer(fp, IOBuffer(), read, write, create)

    # If we're wanting to append data then we we need to prepopulate the internal buffer
    if write && append
        _read(buffer)
        seekend(buffer)
    end

    return buffer
end

Base.isopen(buffer::FileBuffer) = isopen(buffer.io)
Base.isreadable(buffer::FileBuffer) = buffer.read
Base.iswritable(buffer::FileBuffer) = buffer.write
Base.readavailable(buffer::FileBuffer) = read(buffer)
Base.seek(buffer::FileBuffer, n::Integer) = (_read(buffer); seek(buffer.io, n))
Base.skip(buffer::FileBuffer, n::Integer) = (_read(buffer); skip(buffer.io, n))
Base.seekstart(buffer::FileBuffer) = seekstart(buffer.io)
Base.seekend(buffer::FileBuffer) = (_read(buffer); seekend(buffer.io))
Base.position(buffer::FileBuffer) = position(buffer.io)
Base.eof(buffer::FileBuffer) = (_read(buffer); eof(buffer.io))

function _read(buffer::FileBuffer)
    # If our IOBuffer is empty then populate it with the
    # filepath contents
    if buffer.io.size == 0
        write(buffer.io, read(buffer.path))
        seekstart(buffer.io)
    end
end

function Base.read(buffer::FileBuffer)
    isreadable(buffer) || throw(ArgumentError("read failed, FileBuffer is not readable"))
    _read(buffer)
    seekstart(buffer)
    return read(buffer.io)
end

function Base.read(buffer::FileBuffer, ::Type{String})
    isreadable(buffer) || throw(ArgumentError("read failed, FileBuffer is not readable"))
    _read(buffer)
    seekstart(buffer)
    return read(buffer.io, String)
end

function Base.read(buffer::FileBuffer, ::Type{UInt8})
    if buffer.io.size == 0
        write(buffer.io, read(buffer.path))
        seekstart(buffer)
    end
    return read(buffer.io, UInt8)
end

#=
NOTE: We need to define multiple methods because of ambiguity error with base IO methods.
=#
function Base.write(buffer::FileBuffer, x::Vector{UInt8})
    iswritable(buffer) || throw(ArgumentError("write failed, FileBuffer is not writeable"))
    return write(buffer.io, x)
end

function Base.write(buffer::FileBuffer, x::String)
    iswritable(buffer) || throw(ArgumentError("write failed, FileBuffer is not writeable"))
    return write(buffer.io, x)
end

function Base.write(buffer::FileBuffer, x::UInt8)
    iswritable(buffer) || throw(ArgumentError("write failed, FileBuffer is not writeable"))
    return write(buffer.io, x)
end

function Base.flush(buffer::FileBuffer)
    if iswritable(buffer)
        seekstart(buffer)
        write(buffer.path, read(buffer.io))
    end
end

function Base.close(buffer::FileBuffer)
    flush(buffer)
    return close(buffer.io)
end

@static if Sys.isapple()
    struct Cpasswd
        pw_name::Cstring
        pw_passwd::Cstring
        pw_uid::Cint
        pw_gid::Cint
        pw_change::Cint
        pw_class::Cstring
        pw_gecos::Cstring
        pw_dir::Cstring
        pw_shell::Cstring
        pw_expire::Cint
        pw_fields::Cint
    end
elseif Sys.islinux()
    struct Cpasswd
        pw_name::Cstring
        pw_passwd::Cstring
        pw_uid::Cint
        pw_gid::Cint
        pw_gecos::Cstring
        pw_dir::Cstring
        pw_shell::Cstring
    end
else
    struct Cpasswd
        pw_name::Cstring
        pw_uid::Cint
        pw_gid::Cint
        pw_dir::Cstring
        pw_shell::Cstring
    end

    Cpasswd() = Cpasswd(pointer("NA"), 0, 0, pointer("NA"), pointer("NA"))
end

struct Cgroup
    gr_name::Cstring
    gr_passwd::Cstring
    gr_gid::Cint
end

Cgroup() = Cgroup(pointer("NA"), pointer("NA"), 0)

struct User
    name::String
    uid::UInt64
    gid::UInt64
    dir::String
    shell::String
end

function User(ps::Cpasswd)
    return User(
        unsafe_string(ps.pw_name),
        UInt64(ps.pw_uid),
        UInt64(ps.pw_gid),
        unsafe_string(ps.pw_dir),
        unsafe_string(ps.pw_shell),
    )
end

User(passwd::Ptr{Cpasswd}) = User(unsafe_load(passwd))
Base.show(io::IO, user::User) = print(io, "$(user.uid) ($(user.name))")

@static if Sys.isunix()
    function User(name::String)
        Libc.errno(0)
        ps = ccall(:getpwnam, Ptr{Cpasswd}, (Ptr{UInt8},), name)
        ret = Libc.errno()

        systemerror(:getpwnam, !iszero(ret))
        ps == C_NULL && throw(ArgumentError("User $name not found."))

        return User(ps)
    end

    function User(uid::UInt)
        Libc.errno(0)
        ps = ccall(:getpwuid, Ptr{Cpasswd}, (UInt64,), uid)
        ret = Libc.errno()

        systemerror(:getpwuid, !iszero(ret))

        if ps == C_NULL
            @warn "User $uid not found."
            return User("NA", uid, uid, "NA", "NA")
        else
            return User(ps)
        end
    end

    User() = User(UInt(ccall(:geteuid, Cint, ())))
else
    User(name::String) = User(Cpasswd())
    User(uid::UInt) = User(Cpasswd())
    User() = User(UInt64(0))
end

struct Group
    name::String
    gid::UInt64
end

Group(gr::Cgroup) = Group(unsafe_string(gr.gr_name), UInt64(gr.gr_gid))
Group(group::Ptr{Cgroup}) = Group(unsafe_load(group))
Base.show(io::IO, group::Group) = print(io, "$(group.gid) ($(group.name))")

@static if Sys.isunix()
    function Group(name::String)
        Libc.errno(0)
        gr = ccall(:getgrnam, Ptr{Cgroup}, (Ptr{UInt8},), name)
        ret = Libc.errno()

        systemerror(:getgrnam, !iszero(ret))
        gr == C_NULL && throw(ArgumentError("Group $name not found."))
        return Group(gr)
    end

    function Group(gid::UInt)
        Libc.errno(0)
        gr = ccall(:getgrgid, Ptr{Cgroup}, (UInt64,), gid)
        ret = Libc.errno()

        systemerror(:getgrgid, !iszero(ret))
        if gr == C_NULL
            @warn "Group $gid not found."
            return Group("NA", gid)
        else
            return Group(gr)
        end
    end

    Group() = Group(UInt(ccall(:getegid, Cint, ())))
else
    Group(name::String) = Group(Cgroup())
    Group(uid::UInt) = Group(Cgroup())
    Group() = Group(UInt64(0))
end

"""
    Path() -> SystemPath
    Path(fp::Tuple) -> SystemPath
    Path(fp::AbstractString) -> AbstractPath
    Path(fp::P; overrides...) -> P

Responsible for creating the appropriate platform specific path
(e.g., [PosixPath](@ref) and [WindowsPath`](@ref) for Unix and
Windows systems respectively)
"""
function Path end

function Path(fp::T; overrides...) where {T<:AbstractPath}
    override_fields = keys(overrides)
    override_vals = values(overrides)

    return T(
        (
            s in override_fields ? override_vals[s] : getfield(fp, s) for s in fieldnames(T)
        )...,
    )
end

Path(str::AbstractString) = parse(AbstractPath, str)

"""
    @p_str -> Path

Constructs a [Path](@path) (platform specific subtype of [AbstractPath](@ref)),
such as `p"~/.juliarc.jl"`.
"""
macro p_str(fp)
    return :(Path($fp))
end

function Base.getproperty(fp::T, attr::Symbol) where {T<:AbstractPath}
    if isdefined(fp, attr)
        return getfield(fp, attr)
    elseif attr === :drive
        return ""
    elseif attr === :root
        return POSIX_PATH_SEPARATOR
    elseif attr === :anchor
        return fp.drive * fp.root
    elseif attr === :separator
        return POSIX_PATH_SEPARATOR
    else
        # Call getfield even though we know it'll error
        # so the message is consistent.
        return getfield(fp, attr)
    end
end

function Base.propertynames(::T, private::Bool=false) where {T<:AbstractPath}
    public_names = (:drive, :root, :anchor, :separator)
    return private ? Base.merge_names(public_names, fieldnames(T)) : public_names
end

#=
We only want to print the macro string syntax when compact is true and
we want print to just return the string (this allows `string` to work normally)
=#
function Base.print(io::IO, fp::AbstractPath)
    return print(io, fp.anchor * join(fp.segments, fp.separator))
end

function Base.show(io::IO, fp::AbstractPath)
    return get(io, :compact, false) ? print(io, fp) : print(io, "p\"$fp\"")
end

# Needed for path Cmd interpolation to work correctly.
# If this isn't defined the fact that a path is iterable will result in each segment being
# treated as a separate argument.
Base.arg_gen(fp::AbstractPath) = Base.arg_gen(string(fp))

# Default string constructors for AbstractPath types should fall back to calling `parse`.
(::Type{T})(str::AbstractString) where {T<:AbstractPath} = parse(T, str)

function Base.parse(::Type{P}, str::AbstractString; kwargs...) where {P<:AbstractPath}
    result = tryparse(P, str; kwargs...)
    result === nothing && throw(ArgumentError("$str cannot be parsed as $P"))
    return result
end

function Base.tryparse(::Type{AbstractPath}, str::AbstractString; debug=false)
    result = nothing
    types = Vector{eltype(PATH_TYPES)}()

    for P in PATH_TYPES
        r = tryparse(P, str)

        # If we successfully parsed the path then save that result
        # and break if we aren't in debug mode, otherwise record how many
        if r !== nothing
            # Only assign the result if it's currently `nothing`
            result = result === nothing ? r : result

            if debug
                push!(types, P)
            else
                break
            end
        end
    end

    if length(types) > 1
        @debug(
            string(
                "Found multiple path types that could parse the string specified ($types). ",
                "Please use a specific `parse` method if $(first(types)) is not the correct type.",
            )
        )
    end

    return result
end

Base.convert(T::Type{<:AbstractPath}, x::AbstractString) = parse(T, x)
Base.convert(::Type{String}, x::AbstractPath) = string(x)
Base.promote_rule(::Type{String}, ::Type{<:AbstractPath}) = String
Base.isless(a::P, b::P) where {P<:AbstractPath} = isless(a.segments, b.segments)

"""
      cwd() -> SystemPath

Get the current working directory.

# Examples
```julia-repl
julia> cwd()
p"/home/JuliaUser"

julia> cd(p"/home/JuliaUser/Projects/julia")

julia> cwd()
p"/home/JuliaUser/Projects/julia"
```
"""
cwd() = Path(pwd())
home() = Path(homedir())
Base.expanduser(fp::AbstractPath) = fp
Base.broadcastable(fp::AbstractPath) = Ref(fp)

# components(fp::AbstractPath) = tuple(drive(fp), root(fp), path(fp)...)

"""
    isrelative(fp::AbstractPath) -> Bool

Returns true if `fp.root` is empty, indicating that it is a relative path.
"""
isrelative(fp::AbstractPath) = isempty(fp.root)

"""
    isabsolute(fp::AbstractPath) -> Bool

Returns true if `fp.root` is not empty, indicating that it is an absolute path.
"""
isabsolute(fp::AbstractPath) = !isempty(fp.root)

# Support immutable indexing API
Base.getindex(fp::AbstractPath, idx) = fp.segments[idx]
Base.firstindex(::AbstractPath) = 1
Base.lastindex(fp::AbstractPath) = length(fp)

# Support iteration protocol
Base.eltype(::AbstractPath) = String
Base.length(fp::AbstractPath) = length(fp.segments)
Base.iterate(fp::AbstractPath, state=1) = iterate(fp.segments, state)

#=
Path Modifiers
===============================================
The following are methods for working with and extracting
path components
=#
"""
    hasparent(fp::AbstractPath) -> Bool

Returns whether there is a parent directory component to the supplied path.
"""
hasparent(fp::AbstractPath) = length(fp.segments) > isrelative(fp)

"""
    parent{T<:AbstractPath}(fp::T) -> T

Returns the parent of the supplied path. If no parent exists
then either "/" or "." will be returned depending on whether the path
is absolute.

# Example
```jldoctest
julia> parent(p"~/.julia/v0.6/REQUIRE")
p"~/.julia/v0.6"

julia> parent(p"/etc")
p"/"

julia> parent(p"etc")
p"."

julia> parent(p".")
p"."
```
"""
Base.parent(fp::AbstractPath) = parents(fp)[end]

"""
    parents{T<:AbstractPath}(fp::T) -> Array{T}

Return all parents of the path. If no parent exists then either "/" or "."
will be returned depending on whether the path is absolute.

# Example
```jldoctest
julia> parents(p"~/.julia/v0.6/REQUIRE")
3-element Array{PosixPath,1}:
 p"~"
 p"~/.julia"
 p"~/.julia/v0.6"

julia> parents(p"/etc")
1-element Array{PosixPath,1}:
 p"/"

julia> parents(p"etc")
1-element Array{PosixPath,1}:
 p"."

julia> parents(p".")
1-element Array{PosixPath,1}:
 p"."
```
"""
function parents(fp::T) where {T<:AbstractPath}
    if hasparent(fp)
        # Iterate from 1:n-1 or 0:n-1 for relative and absolute paths respectively.
        # (i.e., include fp.root when applicable)
        return [
            Path(fp; segments=fp.segments[1:i]) for
            i in isrelative(fp):(length(fp.segments) - 1)
        ]
    elseif fp.segments == tuple(".") || !isempty(fp.root)
        return [fp]
    else
        return [Path(fp; segments=tuple("."))]
    end
end

"""
  *(a::T, b::Union{T, AbstractString, AbstractChar}...) where {T <: AbstractPath} -> T

Concatenate paths, strings and/or characters, producing a new path.
This is equivalent to concatenating the string representations of paths and other strings
and then constructing a new path.

# Example
```jldoctest
julia> p"foo" * "bar"
p"foobar"
```
"""
function Base.:(*)(a::T, b::Union{T,AbstractString,AbstractChar}...) where {T<:AbstractPath}
    return parse(T, *(string(a), string.(b)...))
end

"""
  /(a::AbstractPath, b::Union{AbstractPath, AbstractString}...) -> AbstractPath

Join the path components into a new full path, equivalent to calling `joinpath`.

# Example
```jldoctest
julia> p"foo" / "bar"
p"foo/bar"

julia> p"foo" / "bar" / "baz"
p"foo/bar/baz"
```
"""
/(root::AbstractPath, pieces::Union{AbstractPath,AbstractString}...) = join(root, pieces...)

"""
    join(root::AbstractPath, pieces::Union{AbstractPath, AbstractString}...) -> AbstractPath

Joins path components into a full path.

# Example
```jldoctest; setup = :(using FilePathsBase: /, join)
julia> join(p"~/.julia/v0.6", "REQUIRE")
p"~/.julia/v0.6/REQUIRE"
```
"""
function join(prefix::AbstractPath, pieces::Union{AbstractPath,AbstractString}...)
    pre = prefix
    segments = String[pre.segments...]

    # Convert any strings to paths
    for p in (isa(x, AbstractPath) ? x : Path(x) for x in pieces)
        # Replace prefix if a piece is actually an absolute path.
        if isabsolute(p)
            pre = p
            segments = String[pre.segments...]
        else
            append!(segments, p.segments)
        end
    end

    return Path(pre; segments=tuple(segments...))
end

function Base.splitext(fp::AbstractPath)
    new_fp, ext = splitext(string(fp))
    return (Path(new_fp), ext)
end

Base.basename(fp::AbstractPath) = fp.segments[end]

Base.splitdir(path::AbstractPath) = (dirname(path), basename(path))

"""
    filename(fp::AbstractPath) -> AbstractString

Extracts the `basename` without the extension.

# Example
```jldoctest
julia> filename(p"~/repos/FilePathsBase.jl/src/FilePathsBase.jl")
"FilePathsBase"

julia> filename(p"~/Downloads/julia-1.4.0-linux-x86_64.tar.gz")
"julia-1.4.0-linux-x86_64.tar"
```
"""
filename(fp::AbstractPath) = rsplit(basename(fp), "."; limit=2)[1]

"""
    extension(fp::AbstractPath) -> AbstractString

Extracts the last extension from a filename if there any, otherwise it returns an empty string.

# Example
```jldoctest
julia> extension(p"~/repos/FilePathsBase.jl/src/FilePathsBase.jl")
"jl"
```
"""
function extension(fp::AbstractPath)
    name = basename(fp)

    tokenized = split(name, '.')
    if length(tokenized) > 1
        return tokenized[end]
    else
        return ""
    end
end

"""
    extensions(fp::AbstractPath) -> AbstractString

Extracts all extensions from a filename if there any, otherwise it returns an empty string.

# Example
```jldoctest
julia> extensions(p"~/repos/FilePathsBase.jl/src/FilePathsBase.jl.bak")
2-element Array{SubString{String},1}:
 "jl"
 "bak"
```
"""
function extensions(fp::AbstractPath)
    name = basename(fp)

    tokenized = split(name, '.')
    if length(tokenized) > 1
        return tokenized[2:end]
    else
        return []
    end
end

"""
    isempty(fp::AbstractPath) -> Bool

Returns whether or not a path is empty.

NOTE: Empty paths are usually only created by `Path()`, as `p""` and `Path("")` will
default to using the current directory (or `p"."`).
"""
Base.isempty(fp::AbstractPath) = isempty(fp.segments)

"""
    normalize(fp::AbstractPath) -> AbstractPath

normalizes a path by removing "." and ".." entries.
"""
function normalize(fp::T) where {T<:AbstractPath}
    p = fp.segments
    result = String[]
    rem = length(p)
    count = 0
    del = 0

    while count < length(p)
        str = p[end - count]

        if str == ".."
            del += 1
        elseif str != "."
            if del == 0
                push!(result, str)
            else
                del -= 1
            end
        end

        rem -= 1
        count += 1
    end

    return Path(fp; segments=tuple(fill("..", del)..., reverse(result)...))
end

"""
    absolute(fp::AbstractPath) -> AbstractPath

Creates an absolute path by adding the current working directory if necessary.
"""
function absolute(fp::AbstractPath)
    result = expanduser(fp)

    if isabsolute(result)
        return normalize(result)
    else
        return normalize(join(cwd(), result))
    end
end

"""
    relative{T<:AbstractPath}(fp::T, start::T=cwd())

Creates a relative path from either the current directory or an arbitrary start directory.
"""
function relative(fp::T, start::T=cwd()) where {T<:AbstractPath}
    curdir = "."
    pardir = ".."

    p = absolute(fp).segments
    s = absolute(start).segments

    p == s && return parse(T, curdir)

    i = 0
    while i < min(length(p), length(s))
        i += 1
        @static if Sys.iswindows()
            if lowercase(p[i]) != lowercase(s[i])
                i -= 1
                break
            end
        else
            if p[i] != s[i]
                i -= 1
                break
            end
        end
    end

    pathpart = p[(i + 1):findlast(x -> !isempty(x), p)]
    prefix_num = findlast(x -> !isempty(x), s) - i - 1
    if prefix_num >= 0
        relpath_ = if isempty(pathpart)
            tuple(fill(pardir, prefix_num + 1)...)
        else
            tuple(fill(pardir, prefix_num + 1)..., pathpart...)
        end
    else
        relpath_ = tuple(pathpart...)
    end

    if isempty(relpath_)
        return parse(T, curdir)
    else
        # Our assumption is that relative paths shouldn't have a root or drive.
        # This seems to be consistent with Filesystem on Posix and Windows paths.
        return Path(fp; segments=relpath_, drive="", root="")
    end
end

"""
    canonicalize(path::AbstractPath) -> AbstractPath

Canonicalize a path by making it absolute, `.` or `..` segments and resolving any symlinks
if applicable.

WARNING: Fallback behaviour ignores symlinks and should be extended for paths where
symlinks are permitted (e.g., `SystemPath`s).
"""
canonicalize(fp::AbstractPath) = normalize(absolute(fp))

Base.lstat(fp::AbstractPath) = stat(fp)

"""
    mode(fp::AbstractPath) -> Mode

Returns the `Mode` for the specified path.

# Example
```julia-repl
julia> mode(p"src/FilePathsBase.jl")
-rw-r--r--
```
"""
mode(fp::AbstractPath) = stat(fp).mode
Base.filesize(fp::AbstractPath) = stat(fp).size

"""
    modified(fp::AbstractPath) -> DateTime

Returns the last modified date for the `path`.

# Example
```julia-repl
julia> modified(p"src/FilePathsBase.jl")
2017-06-20T04:01:09
```
"""
modified(fp::AbstractPath) = stat(fp).mtime

"""
    created(fp::AbstractPath) -> DateTime

Returns the creation date for the `path`.

# Example
```julia-repl
julia> created(p"src/FilePathsBase.jl")
2017-06-20T04:01:09
```
"""
created(fp::AbstractPath) = stat(fp).ctime
Base.isdir(fp::AbstractPath) = isdir(mode(fp))
Base.isfile(fp::AbstractPath) = isfile(mode(fp))
Base.islink(fp::AbstractPath) = islink(lstat(fp).mode)
Base.issocket(fp::AbstractPath) = issocket(mode(fp))
Base.isfifo(fp::AbstractPath) = issocket(mode(fp))
Base.ischardev(fp::AbstractPath) = ischardev(mode(fp))
Base.isblockdev(fp::AbstractPath) = isblockdev(mode(fp))

"""
    cp(src::AbstractPath, dst::AbstractPath; force=false, follow_symlinks=false)

Copy the file or directory from `src` to `dst`. An existing `dst` will only be overwritten
if `force=true`. If the path types support symlinks then `follow_symlinks=true` will
copy the contents of the symlink to the destination.
"""
function Base.cp(src::AbstractPath, dst::AbstractPath; force=false, follow_symlinks=false)
    if exists(dst)
        if force
            rm(dst; force=force, recursive=true)
        else
            throw(ArgumentError("Destination already exists: $dst"))
        end
    end

    if !exists(src)
        throw(ArgumentError("Source path does not exist: $src"))
    elseif isdir(src)
        mkdir(dst)

        for fp in readdir(src)
            cp(src / fp, dst / fp; force=force)
        end
    elseif isfile(src)
        write(dst, read(src))
    elseif islink(src)
        follow_symlinks ? symlink(readlink(src), dst) : write(dst, read(canonicalize(src)))
    else
        throw(ArgumentError("Source path is not a file or directory: $src"))
    end

    return dst
end

"""
    mv(src::AbstractPath, dst::AbstractPath; force=false)

Move the file or director from `src` to `dst`. An exist `dst` will only be overwritten if
`force=true`.
"""
function Base.mv(src::AbstractPath, dst::AbstractPath; force=false)
    cp(src, dst; force=force)
    rm(src; recursive=true)
    return dst
end

"""
    sync([f::Function,] src::AbstractPath, dst::AbstractPath; delete=false, overwrite=true)

Recursively copy new and updated files from the source path to the destination.
If delete is true then files at the destination that don't exist at the source will be removed.
By default, source files are sent to the destination if they have different sizes or the source has newer
last modified date.

Optionally, you can specify a function `f` which will take a `src` and `dst` path and return
true if the `src` should be sent. This may be useful if you'd like to use a checksum for
comparison.
"""
function sync(src::AbstractPath, dst::AbstractPath; kwargs...)
    return sync(should_sync, src, dst; kwargs...)
end

function sync(
    f::Function, src::AbstractPath, dst::AbstractPath; delete=false, overwrite=true
)
    # Throw an error if the source path doesn't exist at all
    exists(src) || throw(ArgumentError("$src does not exist"))

    # If the top level source is just a file then try to just sync that
    # without calling walkpath
    if isfile(src)
        # If the destination exists then we should make sure it is a file and check
        # if we should copy the source over.
        if exists(dst)
            isfile(dst) || throw(ArgumentError("$dst is not a file"))
            if overwrite && f(src, dst)
                cp(src, dst; force=true)
            end
        else
            cp(src, dst)
        end
    else
        isdir(src) || throw(ArgumentError("$src is neither a file or directory."))
        if exists(dst) && !isdir(dst)
            throw(ArgumentError("$dst is not a directory while $src is"))
        end

        # Create an index of all of the source files
        src_paths = collect(walkpath(src))
        index = Dict(
            Tuple(setdiff(p.segments, src.segments)) => i for (i, p) in enumerate(src_paths)
        )

        if exists(dst)
            for p in walkpath(dst)
                k = Tuple(setdiff(p.segments, dst.segments))

                if haskey(index, k)
                    src_path = src_paths[index[k]]
                    if overwrite && f(src_path, p)
                        cp(src_path, p; force=true)
                    end

                    delete!(index, k)
                elseif delete
                    rm(p; recursive=true)
                end
            end

            # Finally, copy over files that don't exist at the destination
            # But we need to iterate through it in a way that respects the original
            # walkpath order otherwise we may end up trying to copy a file before its parents.
            index_pairs = collect(pairs(index))
            index_pairs = index_pairs[sortperm(last.(index_pairs))]
            for (seg, i) in index_pairs
                cp(
                    src_paths[i],
                    Path(dst; segments=tuple(dst.segments..., seg...));
                    force=true,
                )
            end
        else
            cp(src, dst)
        end
    end
end

function should_sync(src::AbstractPath, dst::AbstractPath)
    src_stat = stat(src)
    dst_stat = stat(dst)

    if src_stat.size != dst_stat.size || src_stat.mtime > dst_stat.mtime
        @debug(
            "syncing: $src -> $dst, " *
                "size: $(src_stat.size) -> $(dst_stat.size), " *
                "modified_time: $(src_stat.mtime) -> $(dst_stat.mtime)"
        )
        return true
    else
        return false
    end
end

"""
    download(url::Union{AbstractString, AbstractPath}, localfile::AbstractPath)

Download a file from the remote `url` and save it to the `localfile` path.

NOTE: Not downloading into a `localfile` directory matches the base Julia behaviour.
https://github.com/rofinn/FilePathsBase.jl/issues/48
"""
function Base.download(url::AbstractString, localfile::P) where {P<:AbstractPath}
    mktemp(P) do fp, io
        download(url, fp)
        cp(fp, localfile; force=false)
    end
end

Base.download(url::AbstractPath, localfile::AbstractPath) = cp(url, localfile; force=true)

function Base.download(url::AbstractPath, localfile::AbstractString)
    download(url, Path(localfile))
    return localfile
end

"""
    readpath(fp::P; join=true, sort=true) where {P <: AbstractPath} -> Vector{P}
"""
function readpath(p::P; join=true, sort=true)::Vector{P} where {P<:AbstractPath}
    @static if VERSION < v"1.4"
        results = readdir(p)
        sort && sort!(results)
        return join ? joinpath.(p, results) : parse.(P, results)
    else
        return parse.(P, readdir(p; join=join, sort=sort))
    end
end

"""
    walkpath(fp::AbstractPath; topdown=true, follow_symlinks=false, onerror=throw)

Performs a depth first search through the directory structure
"""
function walkpath(
    fp::P; topdown=true, follow_symlinks=false, onerror=throw
) where {P<:AbstractPath}
    return Channel(; ctype=P) do chnl
        for p in readpath(fp)
            topdown && put!(chnl, p)
            if isdir(p) && (follow_symlinks || !islink(p))
                # Iterate through children
                children = walkpath(
                    p; topdown=topdown, follow_symlinks=follow_symlinks, onerror=onerror
                )

                for c in children
                    put!(chnl, c)
                end
            end
            topdown || put!(chnl, p)
        end
    end
end

"""
  open(filename::AbstractPath; keywords...) -> FileBuffer
  open(filename::AbstractPath, mode="r) -> FileBuffer

Return a default FileBuffer for `open` calls to paths which only support `read` and `write`
methods. See base `open` docs for details on valid keywords.
"""
Base.open(fp::AbstractPath; kwargs...) = FileBuffer(fp; kwargs...)

function Base.open(fp::AbstractPath, mode)
    if mode == "r"
        return FileBuffer(fp; read=true, write=false)
    elseif mode == "w"
        return FileBuffer(fp; read=false, write=true, create=true, truncate=true)
    elseif mode == "a"
        return FileBuffer(fp; read=false, write=true, create=true, append=true)
    elseif mode == "r+"
        return FileBuffer(fp; read=true, writable=true)
    elseif mode == "w+"
        return FileBuffer(fp; read=true, write=true, create=true, truncate=true)
    elseif mode == "a+"
        return FileBuffer(fp; read=true, write=true, create=true, append=true)
    else
        throw(ArgumentError("$mode is not support for $(typeof(fp))"))
    end
end

# Fallback read write methods
Base.read(fp::AbstractPath, ::Type{T}) where {T} = open(io -> read(io, T), fp)
Base.write(fp::AbstractPath, x) = open(io -> write(io, x), fp, "w")

# Default `touch` will just write an empty string to a file
Base.touch(fp::AbstractPath) = write(fp, "")

Base.tempname(::Type{<:AbstractPath}) = Path(tempname())
tmpname() = tempname(SystemPath)

Base.tempdir(::Type{<:AbstractPath}) = Path(tempdir())
tmpdir() = tempdir(SystemPath)

Base.mktemp(P::Type{<:AbstractPath}) = mktemp(tempdir(P))
mktmp() = mktemp(SystemPath)

Base.mktemp(fn::Function, P::Type{<:AbstractPath}) = mktemp(fn, tempdir(P))
mktmp(fn::Function) = mktemp(fn, SystemPath)

Base.mktempdir(P::Type{<:AbstractPath}) = mktempdir(tempdir(P))
mktmpdir() = mktempdir(SystemPath)

Base.mktempdir(fn::Function, P::Type{<:AbstractPath}) = mktempdir(fn, tempdir(P))
mktmpdir(fn::Function) = mktempdir(fn, SystemPath)

function Base.mktemp(parent::AbstractPath)
    fp = parent / string(uuid4())
    # touch the file in case `open` isn't implement for the path and
    # we're buffering locally.
    touch(fp)
    io = open(fp, "w+")
    return fp, io
end

function Base.mktempdir(parent::AbstractPath)
    fp = parent / string(uuid4())
    mkdir(fp)
    return fp
end

function Base.mktemp(fn::Function, parent::AbstractPath)
    (tmp_fp, tmp_io) = mktmp(parent)
    try
        fn(tmp_fp, tmp_io)
    finally
        close(tmp_io)
        rm(tmp_fp)
    end
end

function Base.mktempdir(fn::Function, parent::AbstractPath)
    tmpdir = mktmpdir(parent)
    try
        fn(tmpdir)
    finally
        rm(tmpdir; recursive=true)
    end
end

mktmp(arg1, args...) = mktemp(arg1, args...)
mktmpdir(arg1, args...) = mktempdir(arg1, args...)

"""
	isdescendant(fp::P, asc::P) where {P <: AbstractPath} -> Bool

Returns `true` if `fp` is within the directory tree of the `asc`.
"""
isdescendant(fp::P, asc::P) where {P<:AbstractPath} = fp == asc || asc in parents(fp)

"""
	isascendant(fp::P, desc::P) where {P <: AbstractPath} -> Bool

Returns `true` if `fp` is a directory containing `desc`.
"""
isascendant(fp::P, desc::P) where {P<:AbstractPath} = isdescendant(desc, fp)

"""
    diskusage(fp::AbstractPath)

Returns the total size in bytes of the `AbstractPath`.  This is guaranteed to give the same
result as summing the `filesize` of all nodes in `walkpath(fp)` including directory
node block sizes.

This is the preferred method for computing file or directory sizes for remote file
systems as it should limit the number of remote calls where possible.
"""
diskusage(fp::AbstractPath) = isfile(fp) ? filesize(fp) : diskusage(walkpath(fp))
diskusage(itr) = mapreduce(filesize, +, itr)

Base.include(m::Module, path::AbstractPath) = Base.include(identity, m, path)
function Base.include(mapexpr::Function, m::Module, path::AbstractPath)
    tmp_file = cwd() / string(uuid4(), "-", basename(path))
    try
        cp(path, tmp_file; force=true)
        Base.include(mapexpr, m, string(tmp_file))
    finally
        rm(tmp_file; force=true)
    end
end

macro __INCLUDE__()
    return quote
        m = @__MODULE__
        m.include(path::AbstractPath) = Base.include(identity, m, path)
        m.include(mapexpr::Function, path::AbstractPath) = Base.include(mapexpr, m, path)
    end
end

"""
    PosixPath()
    PosixPath(str)

Represents any posix path (e.g., `/home/user/docs`)
"""
struct PosixPath <: SystemPath
    segments::Tuple{Vararg{String}}
    root::String
end

PosixPath() = PosixPath(tuple(), "")
PosixPath(segments::Tuple; root="") = PosixPath(segments, root)

function Base.tryparse(::Type{PosixPath}, str::AbstractString)
    str = string(str)
    isempty(str) && return PosixPath(tuple("."))

    tokenized = split(str, POSIX_PATH_SEPARATOR)
    root = isempty(tokenized[1]) ? POSIX_PATH_SEPARATOR : ""
    return PosixPath(tuple(map(String, filter!(!isempty, tokenized))...), root)
end

function Base.expanduser(fp::PosixPath)::PosixPath
    p = fp.segments

    if length(p) >= 1 && p[1] == "~"
        return length(p) > 1 ? joinpath(home(), p[2:end]...) : home()
    end

    return fp
end

function Base.Filesystem.contractuser(fp::PosixPath)
    h = home()
    if isdescendant(fp, h)
        if fp == h
            return PosixPath("~")
        else
            n = length(h.segments)
            return PosixPath(("~", fp.segments[(n + 1):end]...))
        end
    end

    return fp
end

module TestPkg

using FilePathsBase

import Base: ==

__init__() = FilePathsBase.register(TestPath)

# Warning: We only expect this test to work on posix systems.

struct TestPath <: AbstractPath
    segments::Tuple{Vararg{String}}
    root::String
    drive::String
    separator::String
end

TestPath() = TestPath(tuple(), "", "test:", ";")

function Base.tryparse(::Type{TestPath}, str::AbstractString)
    startswith(str, "test:") || return nothing
    str = String(str)
    drive = "test:"
    str = str[6:end]

    isempty(str) && return TestPath(tuple("."), "", drive)

    tokenized = split(str, ";")
    root = isempty(tokenized[1]) ? ";" : ""

    return TestPath(tuple(map(String, filter!(!isempty, tokenized))...), root, drive, ";")
end

function test2posix(fp::TestPath)
    return PosixPath(fp.segments, isempty(fp.root) ? "" : "/")
end

function posix2test(fp::PosixPath)
    return TestPath(fp.segments, isempty(fp.root) ? "" : ";", "test:", ";")
end

# We're going to implement most of the posix API, but this won't make sense for many path types
FilePathsBase.exists(fp::TestPath) = exists(test2posix(fp))
Base.readlink(fp::TestPath) = posix2test(readlink(test2posix(fp)))
FilePathsBase.canonicalize(fp::TestPath) = posix2test(canonicalize(test2posix(fp)))
FilePathsBase.stat(fp::TestPath) = stat(test2posix(fp))
FilePathsBase.lstat(fp::TestPath) = lstat(test2posix(fp))
FilePathsBase.mode(fp::TestPath) = stat(fp).mode
Base.filesize(fp::TestPath) = stat(fp).size
FilePathsBase.created(fp::TestPath) = stat(fp).ctime
FilePathsBase.modified(fp::TestPath) = stat(fp).mtime
FilePathsBase.isdir(fp::TestPath) = isdir(mode(fp))
Base.isfile(fp::TestPath) = isfile(mode(fp))
Base.islink(fp::TestPath) = islink(lstat(fp).mode)
Base.issocket(fp::TestPath) = issocket(mode(fp))
Base.isfifo(fp::TestPath) = issocket(mode(fp))
Base.ischardev(fp::TestPath) = ischardev(mode(fp))
Base.isblockdev(fp::TestPath) = isblockdev(mode(fp))
Base.ismount(fp::TestPath) = ismount(test2posix(fp))
FilePathsBase.isexecutable(fp::TestPath) = FilePathsBase.isexecutable(test2posix(fp))
Base.iswritable(fp::TestPath) = iswritable(test2posix(fp))
Base.isreadable(fp::TestPath) = isreadable(test2posix(fp))
Base.cd(fp::TestPath) = cd(test2posix(fp))
Base.cd(f::Function, fp::TestPath) = cd(f, test2posix(fp))
Base.mkdir(fp::TestPath; kwargs...) = posix2test(mkdir(test2posix(fp); kwargs...))
function Base.symlink(src::TestPath, dest::TestPath; kwargs...)
    return symlink(test2posix(src), test2posix(dest); kwargs...)
end
Base.rm(fp::TestPath; kwargs...) = rm(test2posix(fp); kwargs...)
Base.read(fp::TestPath) = read(test2posix(fp))
Base.write(fp::TestPath, x) = write(test2posix(fp), x)
Base.chown(fp::TestPath, args...; kwargs...) = chown(test2posix(fp), args...; kwargs...)
Base.chmod(fp::TestPath, args...; kwargs...) = chmod(test2posix(fp), args...; kwargs...)

function Base.readdir(fp::TestPath; join=false, sort=true)
    p = test2posix(fp)
    @static if VERSION < v"1.4"
        return readdir(p)
    else
        results = readdir(p; join=join, sort=sort)
        join || return results
        # Awkward wrapper that converts the readdir output back to a TestPath string.
        return string.(posix2test.(parse.(PosixPath, results)))
    end
end

end

# Posix separator and regex
const POSIX_PATH_SEPARATOR = "/"
const POSIX_PATH_SEPARATOR_RE = r"/+"
const POSIX_PATH_ABSOLUTE_RE = r"^/"
const POSIX_PATH_DIRECTORY_RE = r"(?:^|/)\.{0,2}$"
const POSIX_PATH_DIR_SPLITTER = r"^(.*?)(/+)([^/]*)$"
const POSIX_PATH_EXT_SPLITTER = r"^((?:.*/)?(?:\.|[^/\.])[^/]*?)(\.[^/\.]*|)$"

# Windows separator and regex
const WIN_PATH_SEPARATOR = "\\"
const WIN_PATH_SEPARATOR_RE = r"[/\\]+"
const WIN_PATH_ABSOLUTE_RE = r"^(?:\w+:)?[/\\]"
const WIN_PATH_DIRECTORY_RE = r"(?:^|[/\\])\.{0,2}$"
const WIN_PATH_DIR_SPLITTER = r"^(.*?)([/\\]+)([^/\\]*)$"
const WIN_PATH_EXT_SPLITTER = r"^((?:.*[/\\])?(?:\.|[^/\\\.])[^/\\]*?)(\.[^/\\\.]*|)$"

# The common READ, WRITE and EXEC constants
# to make working with file permissions easier.
const READ = 0o4
const WRITE = 0o2
const EXEC = 0o1

const USER_COEFF = 0o0100
const GROUP_COEFF = 0o0010
const OTHER_COEFF = 0o0001

# Stardard C style file mode constants taken from cpython's
# stat.py file
const S_IFDIR = 0o040000     # directory
const S_IFCHR = 0o020000     # character device
const S_IFBLK = 0o060000     # block device
const S_IFREG = 0o100000     # regular file
const S_IFIFO = 0o010000     # fifo (named pipe)
const S_IFLNK = 0o120000     # symbolic link
const S_IFSOCK = 0o140000     # socket file

const S_ISUID = 0o4000        # set UID bit
const S_ISGID = 0o2000        # set GID bit
const S_ENFMT = S_ISGID       # file locking enforcement
const S_ISVTX = 0o1000        # sticky bit
const S_IREAD = 0o0400        # Unix V7 synonym for S_IRUSR
const S_IWRITE = 0o0200       # Unix V7 synonym for S_IWUSR
const S_IEXEC = 0o0100        # Unix V7 synonym for S_IXUSR
const S_IRWXU = 0o0700        # mask for owner permissions
const S_IRUSR = 0o0400        # read by owner
const S_IWUSR = 0o0200        # write by owner
const S_IXUSR = 0o0100        # execute by owner
const S_IRWXG = 0o0070        # mask for group permissions
const S_IRGRP = 0o0040        # read by group
const S_IWGRP = 0o0020        # write by group
const S_IXGRP = 0o0010        # execute by group
const S_IRWXO = 0o0007        # mask for others (not in group) permissions
const S_IROTH = 0o0004        # read by others
const S_IWOTH = 0o0002        # write by others
const S_IXOTH = 0o0001        # execute by others

const FILEMODE_TABLE = (
    (
        (S_IFLNK, 'l'),
        (S_IFREG, '-'),
        (S_IFBLK, 'b'),
        (S_IFDIR, 'd'),
        (S_IFCHR, 'c'),
        (S_IFIFO, 'p'),
    ),
    ((S_IRUSR, 'r'),),
    ((S_IWUSR, 'w'),),
    ((S_IXUSR | S_ISUID, 's'), (S_ISUID, 'S'), (S_IXUSR, 'x')),
    ((S_IRGRP, 'r'),),
    ((S_IWGRP, 'w'),),
    ((S_IXGRP | S_ISGID, 's'), (S_ISGID, 'S'), (S_IXGRP, 'x')),
    ((S_IROTH, 'r'),),
    ((S_IWOTH, 'w'),),
    ((S_IXOTH | S_ISVTX, 't'), (S_ISVTX, 'T'), (S_IXOTH, 'x')),
)

const DATA_SUFFIX = ["", "K", "M", "G", "T", "P", "E", "Z", "Y"]

# Various aliases to support the Base.Filesystem API or overwrite base behaviour.

# Fallback non-filepath methods if folks explicitly import these symbols
/(args...) = Base.:/(args...)
join(args...) = Base.join(args...)

# Aliases for Base.Filesystem API
# Filesystem methods that were renamed should still have an alias for better interop.
Base.abspath(fp::AbstractPath) = absolute(fp)
Base.ctime(fp::AbstractPath) = datetime2unix(created(fp))
Base.dirname(fp::AbstractPath) = parent(fp)
Base.filemode(fp::AbstractPath) = mode(fp)
Base.isabspath(fp::AbstractPath) = isabsolute(fp)
Base.ispath(fp::AbstractPath) = exists(fp)
function Base.joinpath(root::AbstractPath, pieces::Union{AbstractPath,AbstractString}...)
    return join(root, pieces...)
end
Base.mkpath(fp::AbstractPath) = mkdir(fp; recursive=true, exist_ok=true)
Base.mtime(fp::AbstractPath) = datetime2unix(modified(fp))
Base.normpath(fp::AbstractPath) = normalize(fp)
Base.realpath(fp::AbstractPath) = canonicalize(fp)
Base.relpath(fp::AbstractPath) = relative(fp)
Base.relpath(fp::AbstractPath, src::AbstractPath) = relative(fp, src)

"""
    TestPaths

This module is intended to be used for testing new path types to
ensure that they are adhering to the AbstractPath API.

# Example

```julia
# Create a PathSet
ps = PathSet(; symlink=true)

# Select the subset of tests to run
# Inspect TestPaths.TESTALL to see full list
testsets = [
    test_registration,
    test_show,
    test_cmd,
    test_parse,
    test_convert,
    test_components,
    test_parents,
    test_join,
    test_splitext,
    test_basename,
    test_splitdir,
    test_filename,
    test_extensions,
    test_isempty,
    test_normalize,
    test_canonicalize,
    test_relative,
    test_absolute,
    test_isdir,
    test_isfile,
    test_stat,
    test_filesize,
    test_modified,
    test_created,
    test_cd,
    test_readpath,
    test_walkpath,
    test_read,
    test_write,
    test_mkdir,
    test_cp,
    test_mv,
    test_sync,
    test_symlink,
    test_touch,
    test_tmpname,
    test_tmpdir,
    test_mktmp,
    test_mktmpdir,
    test_download,
    test_include,
]

# Run all the tests
test(ps, testsets)
```
"""
module TestPaths
using Dates: Dates
using FilePathsBase
using FilePathsBase: /, join

export PathSet,
    TESTALL,
    test,
    test_registration,
    test_show,
    test_cmd,
    test_parse,
    test_convert,
    test_components,
    test_indexing,
    test_iteration,
    test_parents,
    test_descendants_and_ascendants,
    test_join,
    test_splitext,
    test_basename,
    test_splitdir,
    test_filename,
    test_extensions,
    test_isempty,
    test_normalize,
    test_canonicalize,
    test_relative,
    test_absolute,
    test_isdir,
    test_isfile,
    test_stat,
    test_filesize,
    test_modified,
    test_created,
    test_issocket,
    test_isfifo,
    test_ischardev,
    test_isblockdev,
    test_ismount,
    test_isexecutable,
    test_isreadable,
    test_iswritable,
    test_cd,
    test_readpath,
    test_walkpath,
    test_read,
    test_write,
    test_mkdir,
    test_cp,
    test_mv,
    test_sync,
    test_symlink,
    test_touch,
    test_tmpname,
    test_tmpdir,
    test_mktmp,
    test_mktmpdir,
    test_chown,
    test_chmod,
    test_download,
    test_include

"""
    PathSet(root::AbstractPath=tmpdir(); symlink=false)

Constructs a common test path hierarchy to running shared API tests.

Hierarchy:

```
root
|-- foo
|   |-- baz.txt
|-- bar
|   |-- qux
|       |-- quux.tar.gz
|-- fred
|   |-- plugh
```
"""
struct PathSet{P<:AbstractPath}
    root::P
    foo::P
    baz::P
    bar::P
    qux::P
    quux::P
    fred::P
    plugh::P
    link::Bool
end

function PathSet(root=tmpdir() / "pathset_root"; symlink=false)
    root = absolute(root)

    return PathSet(
        root,
        root / "foo",
        root / "foo" / "baz.txt",
        root / "bar",
        root / "bar" / "qux",
        root / "bar" / "qux" / "quux.tar.gz",
        root / "fred",
        root / "fred" / "plugh",
        symlink,
    )
end

function initialize(ps::PathSet)
    @info "Initializing $(typeof(ps))"
    mkdir.([ps.foo, ps.qux, ps.fred]; recursive=true, exist_ok=true)
    write(ps.baz, "Hello World!")
    write(ps.quux, "Hello Again!")

    # If link is true then plugh is a symlink to foo
    if ps.link
        symlink(ps.foo, ps.plugh)
    else
        touch(ps.plugh)
    end
end

# NOTE: Most paths should test their own constructors as necessary.

function test_registration end
function test_show end
function test_cmd end
function test_parse end
function test_convert end
function test_components end
function test_indexing end
function test_iteration end
function test_parents end
function test_descendants_and_ascendants end
function test_join end
function test_splitext end
function test_basename end
function test_splitdir end
function test_filename end
function test_extensions end
function test_isempty end
function test_normalize end
function test_canonicalize end
function test_relative end
function test_absolute end
function test_isdir end
function test_isfile end
function test_stat end

# Minimal testing of issocket, isfifo, ischardev, isblockdev and ismount which
# people won't typically include.
function test_issocket end
function test_isfifo end
function test_ischardev end
function test_isblockdev end
function test_ismount end
function test_filesize end
function test_modified end
function test_created end
function test_isexecutable end
function test_isreadable end
function test_iswritable end
function test_cd end
function test_readpath end
function test_walkpath end
function test_read end
function test_write end
function test_mkdir end
function test_cp end
function test_mv end
function test_sync end
function test_symlink end
function test_touch end
function test_tmpname end
function test_tmpdir end
function test_mktmp end
function test_mktmpdir end
function test_chown end
function test_chmod end
function test_download end
function test_include end

TESTALL = [
    test_registration,
    test_show,
    test_cmd,
    test_parse,
    test_convert,
    test_components,
    test_indexing,
    test_iteration,
    test_parents,
    test_descendants_and_ascendants,
    test_join,
    test_splitext,
    test_basename,
    test_filename,
    test_extensions,
    test_isempty,
    test_normalize,
    test_canonicalize,
    test_relative,
    test_absolute,
    test_isdir,
    test_isfile,
    test_stat,
    test_filesize,
    test_modified,
    test_created,
    test_issocket,
    test_isfifo,
    test_ischardev,
    test_isblockdev,
    test_ismount,
    test_isexecutable,
    test_isreadable,
    test_iswritable,
    test_cd,
    test_readpath,
    test_walkpath,
    test_read,
    test_write,
    test_mkdir,
    test_cp,
    test_mv,
    test_symlink,
    test_touch,
    test_tmpname,
    test_tmpdir,
    test_mktmp,
    test_mktmpdir,
    test_chown,
    test_chmod,
    test_download,
    test_include,
]

function test(ps::PathSet, test_sets=TESTALL)
    try
        initialize(ps)

        for ts in test_sets
            ts(ps)
        end
    finally
        rm(ps.root; recursive=true, force=true)
    end
end
end #module

using FilePathsBase: FileBuffer

@testset "FileBuffer Tests" begin
    @testset "read" begin
        p = p"../README.md"
        io = FileBuffer(p)
        try
            @test isopen(io)
            @test isreadable(io)
            @test !iswritable(io)
            @test !eof(io)
            @test position(io) == 0
            @test read(p) == read(io)
            @test eof(io)
            @test position(io) == length(read(p))
            seekstart(io)
            @test position(io) == 0
            @test !eof(io)
            @test read(p, String) == read(io, String)
            @test eof(io)
        finally
            close(io)
            @test !isopen(io)
        end

        io = FileBuffer(p)
        try
            for b in read(p)
                @test read(io, UInt8) == b
            end
            @test eof(io)
        finally
            close(io)
        end

        @test readavailable(FileBuffer(p)) == readavailable(IOBuffer(read(p)))

        # issue #126: data on first read
        mktemp(SystemPath) do p, _
            write(p, "testing")
            io = FilePathsBase.FileBuffer(p)
            @test read(io, 4) == UInt8['t', 'e', 's', 't']
        end
    end

    @testset "seek" begin
        p = p"../README.md"
        io = FileBuffer(p)
        try
            @test position(io) == 0
            @test position(seekend(io)) > 0
            @test position(seekstart(io)) == 0
            @test position(seek(io, 5)) == 5
            @test position(skip(io, 10)) == 15
        finally
            close(io)
        end
    end

    @testset "populate" begin
        funcs = (
            :seek => io -> seek(io, 1),
            :skip => io -> skip(io, 1),
            :seekend => seekend,
            :eof => eof,
        )

        @testset "$name" for (name, f) in funcs
            p = p"../README.md"
            buffer = FileBuffer(p)
            try
                f(buffer)
                @test buffer.io.size > 0
            finally
                close(buffer)
            end
        end
    end

    @testset "write" begin
        mktmpdir() do d
            p1 = absolute(p"../README.md")

            cd(d) do
                p2 = p"README.md"
                cp(p1, p2)

                io = FileBuffer(p2; read=true, write=true)
                try
                    @test isopen(io)
                    @test isreadable(io)
                    @test iswritable(io)
                    @test !eof(io)
                    @test position(io) == 0
                    @test read(p1) == read(io)
                    @test eof(io)
                    write(io, "\nHello")
                    write(io, " World!\n")
                    flush(io)

                    @test position(io) == length(read(p1)) + 14
                    txt1 = read(p1, String)
                    txt2 = read(p2, String)
                    @test txt1 != txt2
                    @test occursin(txt1, txt2)
                    @test occursin("Hello World!", txt2)
                finally
                    close(io)
                    @test !isopen(io)
                end

                rm(p2)

                io = FileBuffer(p2; read=true, write=true)
                try
                    write(io, read(p1))
                    flush(io)

                    @test position(io) == length(read(p1))
                    seekstart(io)
                    @test position(io) == 0
                    for b in read(p1)
                        write(io, b)
                    end
                    flush(io)
                    @test read(p1) == read(p2)
                finally
                    close(io)
                end
            end
        end
    end

    @testset "eof" begin
        mktemp(SystemPath) do p, _
            io = FileBuffer(p; write=true)
            @test eof(io)
            write(io, "Hey")
            flush(io)
            @test eof(io)
            seekstart(io)
            @test !eof(io)
            read(io)
            @test eof(io)
        end
    end

    @testset "Custom Types" begin
        jlso = JLSOFile(:msg => "Hello World!")
        mktmpdir() do d
            cd(d) do
                write(p"hello_world.jlso", jlso)
                new_jlso = read(p"hello_world.jlso", JLSOFile)
                @test new_jlso[:msg] == "Hello World!"

                rm(p"hello_world.jlso")
                data = IOBuffer()
                write(data, jlso)
                open(p"hello_world.jlso", "w") do io
                    for x in take!(data)
                        write(io, x)
                    end
                end

                open(p"hello_world.jlso") do io
                    data = UInt8[]
                    push!(data, read(io, UInt8))

                    while !eof(io)
                        push!(data, read(io, UInt8))
                    end

                    new_jlso = read(IOBuffer(data), JLSOFile)
                    @test new_jlso[:msg] == "Hello World!"
                end
            end
        end
    end
end

function uuid4()
    u = rand(UInt128)
    u &= 0xffffffffffff0fff3fffffffffffffff
    u |= 0x00000000000040008000000000000000
    return UUID(u)
end
# Mostly copied from https://github.com/IainNZ/Humanize.jl/blob/master/src/Humanize.jl#L27
function _datasize(bytes::Number)
    base = 1024.0
    nbytes = float(bytes)
    unit = base
    suffix = first(DATA_SUFFIX)

    for (i, s) in enumerate(DATA_SUFFIX)
        unit = base^i

        if nbytes < unit
            suffix = s
            break
        end
    end
    return string(round(base * nbytes / unit; digits=1)) * suffix
end

"""
    SystemPath

A union of `PosixPath` and `WindowsPath` which is used for writing
methods that wrap base functionality.
"""
abstract type SystemPath <: AbstractPath end

Path() = @static Sys.isunix() ? PosixPath() : WindowsPath()
function Path(pieces::Tuple{Vararg{String}})
    @static Sys.isunix() ? PosixPath(pieces) : WindowsPath(pieces)
end

"""
    @__PATH__ -> SystemPath

@__PATH__ expands to a path with the directory part of the absolute path
of the file containing the macro. Returns an empty Path if run from a REPL or
if evaluated by julia -e <expr>.
"""
macro __PATH__()
    p = Path(dirname(string(__source__.file)))
    return p === nothing ? :(Path()) : :($p)
end

"""
    @__FILEPATH__ -> SystemPath

@__FILEPATH__ expands to a path with the absolute file path of the file
containing the macro. Returns an empty Path if run from a REPL or if
evaluated by julia -e <expr>.
"""
macro __FILEPATH__()
    p = Path(string(__source__.file))
    return p === nothing ? :(Path()) : :($p)
end

"""
    @LOCAL(filespec)

Construct an absolute path to `filespec` relative to the source file
containing the macro call.
"""
macro LOCAL(filespec)
    p = join(Path(dirname(string(__source__.file))), Path(filespec))
    return :($p)
end

exists(fp::SystemPath) = ispath(string(fp))

#=
The following a descriptive methods for paths
built around stat
=#
Base.stat(fp::SystemPath) = Status(stat(string(fp)))
Base.lstat(fp::SystemPath) = Status(lstat(string(fp)))

"""
    mode(fp::SystemPath) -> Mode

Returns the `Mode` for the specified path.

# Example
```
julia> mode(p"src/FilePathsBase.jl")
-rw-r--r--
```
"""
mode(fp::SystemPath) = Mode(stat(string(fp)).mode)
Base.filesize(fp::SystemPath) = stat(string(fp)).size

"""
    modified(fp::SystemPath) -> DateTime

Returns the last modified date for the `path`.

# Example
```
julia> modified(p"src/FilePathsBase.jl")
2017-06-20T04:01:09
```
"""
modified(fp::SystemPath) = unix2datetime(stat(string(fp)).mtime)

"""
    created(fp::SystemPath) -> DateTime

Returns the creation date for the `path`.

# Example
```
julia> created(p"src/FilePathsBase.jl")
2017-06-20T04:01:09
```
"""
created(fp::SystemPath) = unix2datetime(stat(string(fp)).ctime)
Base.isdir(fp::SystemPath) = isdir(mode(fp))
Base.isfile(fp::SystemPath) = isfile(mode(fp))
Base.islink(fp::SystemPath) = islink(lstat(fp).mode)
Base.issocket(fp::SystemPath) = issocket(mode(fp))
Base.isfifo(fp::SystemPath) = issocket(mode(fp))
Base.ischardev(fp::SystemPath) = ischardev(mode(fp))
Base.isblockdev(fp::SystemPath) = isblockdev(mode(fp))

"""
    isexecutable(fp::SystemPath) -> Bool

Returns whether the `path` is executable for the current user.
"""
function isexecutable(fp::SystemPath)
    s = stat(string(fp))
    mode = Mode(s.mode)
    usr = User()

    return (
        isexecutable(mode, :ALL) ||
        isexecutable(mode, :OTHER) ||
        (usr.uid == s.uid && isexecutable(mode, :USER)) ||
        (usr.gid == s.gid && isexecutable(mode, :GROUP))
    )
end

"""
    iswritable(fp::AbstractPath) -> Bool

Returns whether the `path` is writable for the current user.
"""
function Base.iswritable(fp::SystemPath)
    s = stat(string(fp))
    mode = Mode(s.mode)
    usr = User()

    return (
        iswritable(mode, :ALL) ||
        iswritable(mode, :OTHER) ||
        (usr.uid == s.uid && iswritable(mode, :USER)) ||
        (usr.gid == s.gid && iswritable(mode, :GROUP))
    )
end

"""
    isreadable(fp::SystemPath) -> Bool

Returns whether the `path` is readable for the current user.
"""
function Base.isreadable(fp::SystemPath)
    s = stat(string(fp))
    mode = Mode(s.mode)
    usr = User()

    return (
        isreadable(mode, :ALL) ||
        isreadable(mode, :OTHER) ||
        (usr.uid == s.uid && isreadable(mode, :USER)) ||
        (usr.gid == s.gid && isreadable(mode, :GROUP))
    )
end

function Base.ismount(fp::SystemPath)
    isdir(fp) || return false
    s1 = lstat(string(fp))
    # Symbolic links cannot be mount points
    islink(fp) && return false
    s2 = lstat(string(parent(fp)))
    # If a directory and its parent are on different devices,  then the
    # directory must be a mount point
    (s1.device != s2.device) && return true
    (s1.inode == s2.inode) && return true
    return false
end

#=
Path Operations
===============================================
The following are methods for actually manipulating the
filesystem.

NOTE: Currently, we are just wrapping base julia functions,
but in the future we'll likely be handling platform specific
code in the implementation instances.

TODO: Document these once we're comfortable with them.
=#

Base.cd(fp::SystemPath) = cd(string(fp))
function Base.cd(fn::Function, dir::SystemPath)
    old = cwd()
    try
        cd(dir)
        fn()
    finally
        cd(old)
    end
end

function Base.mkdir(
    fp::T; mode=0o777, recursive=false, exist_ok=false
) where {T<:SystemPath}
    if exists(fp)
        if exist_ok
            return fp
        else
            error("$fp already exists.")
        end
    else
        if hasparent(fp) && !exists(parent(fp))
            if recursive
                mkdir(parent(fp); mode=mode, recursive=recursive, exist_ok=exist_ok)
            else
                error(
                    "The parent of $fp does not exist. " *
                    "Pass recursive=true to create it.",
                )
            end
        end

        return parse(T, mkdir(string(fp); mode=mode))
    end
end

function Base.symlink(src::SystemPath, dest::SystemPath; exist_ok=false, overwrite=false)
    if exists(src)
        if exists(dest) && exist_ok && overwrite
            rm(dest; recursive=true)
        end

        if !exists(dest)
            symlink(string(src), string(dest))
        elseif !exist_ok
            error("$dest already exists.")
        end
    else
        error("$src is not a valid path")
    end
end

function Base.rm(fp::SystemPath; kwargs...)
    return rm(string(fp); kwargs...)
end
Base.touch(fp::T) where {T<:SystemPath} = parse(T, touch(string(fp)))
function Base.mktemp(parent::T) where {T<:SystemPath}
    fp, io = mktemp(string(parent))
    return parse(T, fp), io
end

Base.mktempdir(parent::T) where {T<:SystemPath} = parse(T, mktempdir(string(parent)))

"""
    chown(fp::SystemPath, user::AbstractString, group::AbstractString; recursive=false)

Change the `user` and `group` of the `fp`.
"""
function Base.chown(
    fp::SystemPath, user::AbstractString, group::AbstractString; recursive=false
)
    @static if Sys.isunix()
        chown_cmd = String["chown"]
        if recursive
            push!(chown_cmd, "-R")
        end
        append!(chown_cmd, String["$(user):$(group)", string(fp)])

        run(Cmd(chown_cmd))
    else
        error("chown is currently not supported on windows.")
    end

    return fp
end

Base.chown(fp::T, args...) where {T<:SystemPath} = parse(T, chown(string(fp), args...))

"""
    chmod(fp::SystemPath, mode::Mode; recursive=false)
    chmod(fp::SystemPath, mode::Integer; recursive=false)
    chmod(fp::SystemPath, user::UIn8=0o0, group::UInt8=0o0, other::UInt8=0o0; recursive=false)
    chmod(fp::SystemPath, symbolic_mode::AbstractString; recursive=false)

Provides various methods for changing the `mode` of a `fp`.

# Examples
```julia-repl
julia> touch(p"newfile")
Base.Filesystem.File(false, RawFD(-1))

julia> mode(p"newfile")
-rw-r--r--

julia> chmod(p"newfile", 0o755)

julia> mode(p"newfile")
-rwxr-xr-x

julia> chmod(p"newfile", "-x")

julia> mode(p"newfile")
-rw-r--r--

julia> chmod(p"newfile", user=(READ+WRITE+EXEC), group=(READ+EXEC), other=READ)

julia> mode(p"newfile")
-rwxr-xr--

julia> chmod(p"newfile", mode(p"src/FilePathsBase.jl"))

julia> mode(p"newfile")
-rw-r--r--
```
"""
function Base.chmod(fp::T, mode::Mode; recursive=false) where {T<:SystemPath}
    chmod_path = string(fp)
    chmod_mode = raw(mode)

    if isdir(fp) && recursive
        for p in readdir(fp)
            parse(T, chmod(chmod_path, chmod_mode; recursive=recursive))
        end
    end

    return parse(T, chmod(chmod_path, chmod_mode))
end

function Base.chmod(fp::SystemPath, mode::Integer; recursive=false)
    return chmod(fp, Mode(mode); recursive=recursive)
end

function Base.chmod(
    fp::SystemPath; user::UInt8=0o0, group::UInt8=0o0, other::UInt8=0o0, recursive=false
)
    return chmod(fp, Mode(; user=user, group=group, other=other); recursive=recursive)
end

function Base.chmod(fp::SystemPath, symbolic_mode::AbstractString; recursive=false)
    who_char = ['u', 'g', 'o']
    who_actual = [:USER, :GROUP, :OTHER]
    act_char = ['+', '-', '=']
    perm_char = ['r', 'w', 'x']
    perm_actual = [READ, WRITE, EXEC]
    unsupported_perm_char = ['s', 't', 'X', 'u', 'g', 'o']

    tokenized = split(symbolic_mode, act_char)
    if length(tokenized) != 2
        error("Invalid symbolic string expected format <who><action><perm>.")
    end

    who_raw = tokenized[1]
    perm_raw = tokenized[2]

    who = [:ALL]
    perm = 0o0

    for i in 1:3
        if who_char[i] in who_raw
            push!(who, who_actual[i])
        end
    end

    for i in 1:3
        if perm_char[i] in perm_raw
            perm += perm_actual[i]
        end
    end

    for x in unsupported_perm_char
        if x in perm_raw
            error("$x is currently an unsupported permission char for symbolic modes.")
        end
    end

    m = mode(fp)
    new_m = Mode(perm, who...)

    if '+' in symbolic_mode
        chmod(fp, m + new_m; recursive=recursive)
    elseif '-' in symbolic_mode
        chmod(fp, m - new_m; recursive=recursive)
    elseif '=' in symbolic_mode
        chmod(fp, new_m; recursive=recursive)
    else
        error("No valid action found in symbolic mode string.")
    end
end

Base.open(fp::SystemPath, args...) = open(string(fp), args...)
function Base.open(f::Function, fp::SystemPath, args...; kwargs...)
    return open(f, string(fp), args...; kwargs...)
end

Base.read(fp::SystemPath) = read(string(fp))
function Base.write(fp::SystemPath, x::Union{String,Vector{UInt8}}, mode="w")
    open(fp, mode) do f
        write(f, x)
    end
end

Base.readdir(fp::SystemPath; kwargs...) = readdir(string(fp); kwargs...)

#TODO: Base.download is deprecated; use Downloads.download instead (FilePathsBase.jl#173)
function Base.download(url::AbstractString, dest::T) where {T<:SystemPath}
    return parse(T, download(url, string(dest)))
end

function Base.readlink(fp::T) where {T<:SystemPath}
    return parse(T, readlink(string(fp)))
end

function canonicalize(fp::T) where {T<:SystemPath}
    return parse(T, realpath(string(fp)))
end

@static if Base.VERSION >= v"1.5"
    function Base.include(mapexpr::Function, m::Module, path::SystemPath)
        return Base.include(mapexpr, m, string(path))
    end
end

using FilePathsBase
using FilePathsBase: /, join
using Base.Filesystem
using Dates: datetime2unix
using JLSO
using Mmap
using Test

using FilePathsBase.TestPaths

# Support including filepaths code
FilePathsBase.@__INCLUDE__()

include(p"testpkg.jl")

@testset "FilePathsBase" begin
    include(p"mode.jl")
    include(p"buffer.jl")
    include(p"system.jl")

    @static if Sys.isunix()
        # Test that our weird registered path works
        ps = PathSet(TestPkg.posix2test(tmpdir()) / "pathset_root"; symlink=true)

        @testset "`propertynames`" begin
            @test propertynames(ps.root) == (:drive, :root, :anchor, :separator)
            @test propertynames(ps.root, true) ==
                (:drive, :root, :anchor, :separator, :segments)
        end

        @testset "$(typeof(ps.root))" begin
            testsets = [
                test_registration,
                test_show,
                test_cmd,
                test_parse,
                test_convert,
                test_components,
                test_indexing,
                test_iteration,
                test_parents,
                test_descendants_and_ascendants,
                test_join,
                test_splitext,
                test_basename,
                test_splitdir,
                test_filename,
                test_extensions,
                test_isempty,
                test_normalize,
                test_canonicalize,
                test_relative,
                test_absolute,
                test_isdir,
                test_isfile,
                test_stat,
                test_filesize,
                test_modified,
                test_created,
                test_cd,
                test_readpath,
                test_walkpath,
                test_read,
                test_write,
                test_mkdir,
                test_cp,
                test_mv,
                test_symlink,
                test_touch,
                test_tmpname,
                test_tmpdir,
                test_mktmp,
                test_mktmpdir,
                test_download,
                test_issocket,
                # These will also all work for our custom path type,
                # but many implementations won't support them.
                test_isfifo,
                test_ischardev,
                test_isblockdev,
                test_ismount,
                test_isexecutable,
                test_isreadable,
                test_iswritable,
                test_chown,
                test_chmod,
                test_include,
            ]

            # Run all of the automated tests
            test(ps, testsets)
        end
    end
end

module FilePathsBase

using Dates

import Base: ==
import Base: UUID

#v3 of compat overloads Base.include(mapexpr::Function, path::AbstractString)
#on julia 1.6 afterwards this is not necessary.
@static if Base.VERSION < v"1.6"
    using Compat
end

#https://github.com/JuliaLang/julia/pull/53699 makes isexecutable public. 
#we overload that method if available.
@static if isdefined(Base, :isexecutable)
    import Base: isexecutable
end

export
    # Types
    AbstractPath,
    Path,
    SystemPath,
    PosixPath,
    WindowsPath,
    Mode,
    Status,
    FileBuffer,

    # Methods
    cwd,
    home,
    hasparent,
    parents,
    isascendant,
    isdescendant,
    filename,
    extension,
    extensions,
    exists,
    absolute,
    isabsolute,
    mode,
    created,
    modified,
    normalize,
    canonicalize,
    relative,
    isrelative,
    ismount,
    islink,
    cp,
    mv,
    sync,
    tmpname,
    tmpdir,
    mktmp,
    mktmpdir,
    chown,
    executable,
    readable,
    writable,
    raw,
    readpath,
    walkpath,
    diskusage,

    # Macros
    @p_str,
    @__PATH__,
    @__FILEPATH__,

    # Constants
    READ,
    WRITE,
    EXEC

export isexecutable

const PATH_TYPES = Type[]

function __init__()
    # Register the default fallback path type based on the os.
    return register(Sys.iswindows() ? WindowsPath : PosixPath)
end

"""
    AbstractPath

Defines an abstract filesystem path.

# Properties

- `segments::Tuple{Vararg{String}}` - path segments (required)
- `root::String` - path root (defaults to "/")
- `drive::String` - path drive (defaults to "")
- `separator::String` - path separator (defaults to "/")

# Required Methods
- `tryparse(::Type{T}, str::String)` - For parsing string representations of your path
- `read(path::T)`
- `write(path::T, data)`
- `exists(path::T` - whether the path exists
- `stat(path::T)` - File status describing permissions, size and creation/modified times
- `mkdir(path::T; kwargs...)` - Create a new directory
- `rm(path::T; kwags...)` - Remove a file or directory
- `readdir(path::T)` - Scan all files and directories at a specific path level
"""
abstract type AbstractPath end  # Define the AbstractPath here to avoid circular include dependencies

"""
    register(::Type{<:AbstractPath})

Registers a new path type to support using `Path("...")` constructor and p"..." string
macro.
"""
function register(T::Type{<:AbstractPath})
    # We add the type to the beginning of our PATH_TYPES,
    # so that they can take precedence over the Posix and
    # Windows paths.
    return pushfirst!(PATH_TYPES, T)
end

"""
    ispathtype(::Type{T}, x::AbstractString) where T <: AbstractPath

Return a boolean as to whether the string `x` fits the specified the path type.
"""
function ispathtype end

include("aliases.jl")
include("constants.jl")
include("utils.jl")
include("libc.jl")
include("mode.jl")
include("status.jl")
include("buffer.jl")
include("path.jl")
include("system.jl")
include("posix.jl")
include("windows.jl")
include("test_stub.jl")
include("deprecates.jl")

if !isdefined(Base, :get_extension)
    include("../ext/FilePathsBaseMmapExt.jl")
    include("../ext/FilePathsBaseTestExt.jl")
end

end # end of module

using Dates

import Base.Filesystem: StatStruct

struct Status
    device::UInt64
    inode::UInt64
    mode::Mode
    nlink::Int64
    user::User
    group::Group
    rdev::UInt64
    size::Int64
    blksize::Int64
    blocks::Int64
    mtime::DateTime
    ctime::DateTime
end

function Status(s::StatStruct)
    return Status(
        s.device,
        s.inode,
        Mode(s.mode),
        s.nlink,
        User(s.uid),
        Group(s.gid),
        s.rdev,
        s.size,
        s.blksize,
        s.blocks,
        unix2datetime(s.mtime),
        unix2datetime(s.ctime),
    )
end

function Base.show(io::IO, s::Status)
    output =
        "Status(\n" *
        "  device = $(s.device),\n" *
        "  inode = $(s.inode),\n" *
        "  mode = $(s.mode),\n" *
        "  nlink = $(s.nlink),\n" *
        "  uid = $(s.user),\n" *
        "  gid = $(s.group),\n" *
        "  rdev = $(s.rdev),\n" *
        "  size = $(s.size) ($(_datasize(s.size))),\n" *
        "  blksize = $(s.blksize) ($(_datasize(s.blksize))),\n" *
        "  blocks = $(s.blocks),\n" *
        "  mtime = $(s.mtime),\n" *
        "  ctime = $(s.ctime),\n)"

    return print(io, output)
end

module FilePathsBaseTestExt
using Dates: Dates
using FilePathsBase
using FilePathsBase: /, join
using Test
using FilePathsBase.TestPaths

# NOTE: Most paths should test their own constructors as necessary.

function TestPaths.test_registration(ps::PathSet{P}) where {P<:AbstractPath}
    @testset "Path constructor" begin
        str = string(ps.root)
        @test tryparse(P, str) !== nothing
        @test Path(str) == ps.root
        @test p"foo/bar" == Path("foo/bar")
    end
end

function TestPaths.test_show(ps::PathSet)
    @testset "show" begin
        str = string(ps.root)
        # For windows paths
        str = replace(str, "\\" => "/")
        @test sprint(show, ps.root; context=:compat => true) == "p\"$str\""
        # TODO: Figure out why this is broken.
        @test_broken sprint(show, ps.root; context=:compat => false) == str
    end
end

function TestPaths.test_cmd(ps::PathSet)
    @testset "cmd" begin
        str = string(ps.root)
        @test `echo $str` == `echo $(ps.root)`
    end
end

function TestPaths.test_parse(ps::PathSet{P}) where {P<:AbstractPath}
    @testset "parsing" begin
        str = string(ps.root)
        @test parse(P, str) == ps.root
        @test tryparse(P, str) == ps.root
    end
end

function TestPaths.test_convert(ps::PathSet{P}) where {P<:AbstractPath}
    @testset "convert" begin
        str = string(ps.root)
        @test convert(P, str) == ps.root
        @test convert(String, ps.root) == str
    end
end

function TestPaths.test_components(ps::PathSet)
    @testset "components" begin
        str = string(ps.root)
        @test ps.root.anchor == ps.root.drive * ps.root.root
        @test ps.quux.segments[(end - 2):end] == ("bar", "qux", "quux.tar.gz")

        # Check that isless on the path segments works
        @test ps.bar < ps.foo
        @test sort([ps.foo, ps.bar, ps.fred]) == [ps.bar, ps.foo, ps.fred]
    end
end

function TestPaths.test_indexing(ps::PathSet)
    @test firstindex(ps.root) == 1
    @test lastindex(ps.root) == length(ps.root.segments)
    # `begin` indexing was only added in 1.4, so we'll leave this test commented
    # out for now as there isn't a compat for that syntax.
    # @test ps.root[begin] == ps.root.segments[1]
    @test ps.baz[end] == "baz.txt"
    @test ps.quux[(end - 2):end] == ("bar", "qux", "quux.tar.gz")
    @test ps.quux[:] == ps.quux.segments[:]
end

function TestPaths.test_iteration(ps::PathSet)
    @test eltype(ps.root) == String
    @test tuple(ps.quux...) == ps.quux.segments
    @test all(in(ps.quux), ("bar", "qux", "quux.tar.gz"))
end

function TestPaths.test_parents(ps::PathSet)
    @testset "parents" begin
        @test parent(ps.foo) == ps.root
        @test parent(ps.qux) == ps.bar
        @test dirname(ps.foo) == ps.root

        @test hasparent(ps.qux)
        _parents = parents(ps.qux)
        @test _parents[end] == ps.bar
        @test _parents[end - 1] == ps.root
        @test _parents[1] == Path(ps.root; segments=())

        # More abstract path tests for edge cases when no parent exists
        @test hasparent(p"/foo")
        @test hasparent(p"./foo")
        @test hasparent(p"~/foo")
        @test !hasparent(p"foo")
        @test !hasparent(p"~")
        @test !hasparent(p".")
        @test !hasparent(p"/")

        # Test that relative paths with no parents return p"."
        @test parent(Path(basename(ps.foo))) == p"."

        # Test that parent on p"." should be ===
        path = p"."
        @test parent(path) === path

        # Test that parent on p"/" should be ===
        path = p"/"
        @test parent(path) === path

        # Test inclusion of root in parents
        relparents = parents(PosixPath(ps.root.segments, ""))
        absparents = parents(PosixPath(ps.root.segments, "/"))
        @test relparents !== absparents
        @test length(absparents) == length(relparents) + 1
        @test !in(absparents[1], relparents)
        @test absparents[1] == PosixPath((), "/")
    end
end

function TestPaths.test_descendants_and_ascendants(ps::PathSet)
    @testset "descendants and ascendants" begin
        # Test base cases
        @test isdescendant(p"/a/b", p"/")
        @test isdescendant(p"/a/b", p"/a")
        @test isdescendant(p"/a/b/c", p"/a")
        @test isdescendant(p"/a/b", p"/a/b")
        @test !isdescendant(p"/a/b", p"/a/b/c")
        @test !isdescendant(p"/a/b", p"/c")
        @test isascendant(p"/a", p"/a/b")
        @test !isascendant(p"/a/b", p"/a")

        # Test without our path types
        @test isdescendant(ps.foo, ps.root)
        @test isdescendant(ps.qux, ps.root)
        @test isdescendant(ps.foo, ps.foo)
        @test !isdescendant(ps.root, ps.foo)
        @test !isdescendant(ps.root, ps.qux)
        @test isascendant(ps.root, ps.foo)
        @test isascendant(ps.root, ps.quux)
        @test !isascendant(ps.qux, ps.root)
    end
end

function TestPaths.test_join(ps::PathSet)
    @testset "join" begin
        @test join(ps.root, "bar") == ps.bar
        @test ps.root / "foo" / "baz.txt" == ps.baz
        @test ps.root / "foobaz.txt" == ps.root / "foo" * "baz.txt"
        @test ps.root ./ ["foo", "bar"] == [ps.foo, ps.bar]
        @test ps.root / "foo/baz.txt" == ps.baz
        @test ps.root / p"foo/baz.txt" == ps.baz
        @test ps.root / p"foo" / p"baz.txt" == ps.baz
        @test ps.root / p"foo" / "baz.txt" == ps.baz

        # TODO: Maybe normalize this case for the user? {ps.root}/foo/./baz.txt
        @test normalize(ps.root / p"foo" / "" / "baz.txt") == ps.baz

        # Check that joining absolute paths matches base
        @test ps.root / p"/foo/baz.txt" == p"/foo/baz.txt"
    end
end

function TestPaths.test_splitext(ps::PathSet)
    @testset "splitext" begin
        @test splitext(ps.foo) == (ps.foo, "")
        @test splitext(ps.baz) == (ps.foo / "baz", ".txt")
        @test splitext(ps.quux) == (ps.qux / "quux.tar", ".gz")
    end
end
function TestPaths.test_basename(ps::PathSet)
    @testset "basename" begin
        @test basename(ps.foo) == "foo"
        @test basename(ps.baz) == "baz.txt"
        @test basename(ps.quux) == "quux.tar.gz"
    end
end
function TestPaths.test_splitdir(ps::PathSet)
    @testset "splitdir" begin
        @test splitdir(ps.foo) == (ps.root, "foo")
        @test splitdir(ps.baz) == (ps.root / "foo", "baz.txt")
        @test splitdir(ps.quux) == (ps.root / "bar" / "qux", "quux.tar.gz")
    end
end

function TestPaths.test_filename(ps::PathSet)
    @testset "filename" begin
        @test filename(ps.foo) == "foo"
        @test filename(ps.baz) == "baz"
        @test filename(ps.quux) == "quux.tar"
    end
end

function TestPaths.test_extensions(ps::PathSet)
    @testset "extensions" begin
        @test extension(ps.foo) == ""
        @test extension(ps.baz) == "txt"
        @test extension(ps.quux) == "gz"
        @test extensions(ps.foo) == []
        @test extensions(ps.baz) == ["txt"]
        @test extensions(ps.quux) == ["tar", "gz"]
    end
end

function TestPaths.test_isempty(ps::PathSet{P}) where {P<:AbstractPath}
    @testset "isempty" begin
        @test !isempty(ps.foo)
        @test isempty(P())
    end
end

function TestPaths.test_normalize(ps::PathSet)
    @testset "normalize" begin
        @test normalize(ps.bar / ".." / "foo") == ps.foo
        @test normalize(ps.bar / ".") == ps.bar
        @test normpath(ps.bar / ".") == ps.bar
    end
end

function TestPaths.test_canonicalize(ps::PathSet)
    @testset "canonicalize" begin
        # NOTE: We call `canonicalize` on ps.bar in the `normalize` case because on
        # macOS the temp directory may include a symlink.
        @test canonicalize(ps.bar / ".." / "foo") ==
            normalize(canonicalize(ps.bar) / ".." / "foo")
        @test canonicalize(ps.bar / ".") == normalize(canonicalize(ps.bar) / ".")
        @test realpath(ps.bar / ".") == canonicalize(ps.bar / ".")

        if ps.plugh !== nothing
            if isa(ps.plugh, WindowsPath) && VERSION < v"1.2"
                @test_broken canonicalize(ps.plugh) == canonicalize(ps.foo)
            else
                @test canonicalize(ps.plugh) == canonicalize(ps.foo)
            end
        end
    end
end

function TestPaths.test_relative(ps::PathSet)
    @testset "relative" begin
        @test relative(ps.foo, ps.qux).segments == ("..", "..", "foo")
    end
end

function TestPaths.test_absolute(ps::PathSet)
    @testset "absolute" begin
        @test isabsolute(ps.root) || isabsolute(absolute(ps.root))
        @test absolute(ps.root) == abspath(ps.root)
    end
end

function TestPaths.test_isdir(ps::PathSet)
    @testset "isdir" begin
        @test isdir(ps.foo)
        @test !isdir(ps.baz)
    end
end

function TestPaths.test_isfile(ps::PathSet)
    @testset "isfile" begin
        @test isfile(ps.baz)
        @test !isfile(ps.foo)
    end
end

function TestPaths.test_stat(ps::PathSet)
    @testset "stat" begin
        s = stat(ps.root)
        fields = fieldnames(typeof(s))

        @test :size in fields
        @test :ctime in fields
        @test :mtime in fields
        @test :user in fields
        @test :mode in fields

        if ps.link
            @test lstat(ps.plugh) != stat(ps.plugh)
        end

        str = sprint(show, s)
    end
end

# Minimal testing of issocket, isfifo, ischardev, isblockdev and ismount which
# people won't typically include.
function TestPaths.test_issocket(ps::PathSet)
    @test !issocket(ps.root)
end

function TestPaths.test_isfifo(ps::PathSet)
    @test !isfifo(ps.root)
end

function TestPaths.test_ischardev(ps::PathSet)
    @test !ischardev(ps.root)
end

function TestPaths.test_isblockdev(ps::PathSet)
    @test !isblockdev(ps.root)
end

function TestPaths.test_ismount(ps::PathSet)
    @test !ismount(ps.root)
end

function TestPaths.test_filesize(ps::PathSet)
    @testset "filesize" begin
        @test filesize(ps.baz) > 0
    end
end

function TestPaths.test_modified(ps::PathSet)
    @testset "modified" begin
        @test isa(modified(ps.baz), Dates.AbstractDateTime)
        @test modified(ps.baz) >= modified(ps.root)
    end
end

function TestPaths.test_created(ps::PathSet)
    @testset "created" begin
        @test isa(created(ps.baz), Dates.AbstractDateTime)
        @test created(ps.baz) >= created(ps.root)
    end
end

function TestPaths.test_isexecutable(ps::PathSet{P}) where {P<:AbstractPath}
    @testset "isexecutable" begin
        # I'm not entirely sure how to test this generally
        @test !isexecutable(ps.baz)

        # Directories should be executable for system paths
        if P <: SystemPath
            @test isexecutable(ps.foo)
        end
    end
end

function TestPaths.test_isreadable(ps::PathSet)
    @testset "isreadable" begin
        # Our test files should be readable by default
        @test isreadable(ps.baz)
        @test isreadable(ps.quux)

        # Our test directories should also be readable by default
        @test isreadable(ps.foo)
        @test isreadable(ps.qux)
    end
end

function TestPaths.test_iswritable(ps::PathSet)
    @testset "iswritable" begin
        # Our test files should be writable by default
        @test iswritable(ps.baz)
        @test iswritable(ps.quux)

        # Our test directories should also be writable by default
        @test iswritable(ps.foo)
        @test iswritable(ps.qux)
    end
end

function TestPaths.test_cd(ps::PathSet{P}) where {P<:AbstractPath}
    if P <: SystemPath
        @testset "cd" begin
            init_path = canonicalize(cwd())

            cd(ps.foo) do
                cd_path = canonicalize(cwd())
                @test cd_path != init_path
                @test cd_path == canonicalize(ps.foo)
            end

            @test canonicalize(cwd()) == init_path

            cd(ps.qux)
            cd_path = canonicalize(cwd())
            @test cd_path != init_path
            @test cd_path == canonicalize(ps.qux)
            cd(init_path)
            @test canonicalize(cwd()) == init_path
        end
    end
end

function TestPaths.test_readpath(ps::PathSet)
    @testset "readpath" begin
        @test readdir(ps.root) == ["bar", "foo", "fred"]
        @test readdir(ps.qux) == ["quux.tar.gz"]
        @test readpath(ps.root) == [ps.bar, ps.foo, ps.fred]
        @test readpath(ps.qux) == [ps.quux]
    end
end

function TestPaths.test_walkpath(ps::PathSet{P}) where {P}
    @testset "walkpath" begin
        topdown = [ps.bar, ps.qux, ps.quux, ps.foo, ps.baz, ps.fred, ps.plugh]
        bottomup = [ps.quux, ps.qux, ps.bar, ps.baz, ps.foo, ps.plugh, ps.fred]

        @test collect(walkpath(ps.root; topdown=true)) == topdown
        @test collect(walkpath(ps.root; topdown=false)) == bottomup

        @test eltype(walkpath(ps.root)) == P  # should return a typed collection

        # tests consistency of definition, assume network usage acceptable
        @test diskusage(ps.root) == mapreduce(filesize, +, walkpath(ps.root))
        @test diskusage(ps.baz) == ncodeunits("Hello World!")
    end
end

function TestPaths.test_read(ps::PathSet)
    @testset "read" begin
        @test read(ps.baz, String) == "Hello World!"
        open(ps.quux, "r") do io
            @test read(io, String) == "Hello Again!"
        end
    end
end

function TestPaths.test_write(ps::PathSet)
    @testset "write" begin
        write(ps.baz, "Goodbye World!")
        @test read(ps.baz, String) == "Goodbye World!"

        @testset "truncate" begin
            open(ps.quux, "w") do io
                write(io, "Hello?")
            end
            @test read(ps.quux, String) == "Hello?"
        end

        @testset "append" begin
            open(ps.quux, "a") do io
                write(io, " Did you need something?")
            end
            @test read(ps.quux, String) == "Hello? Did you need something?"
        end

        @testset "read/write" begin
            open(ps.quux, "w+") do io
                write(io, "Goodnight!")
                seekstart(io)
                @test read(io, String) == "Goodnight!"
            end

            open(ps.quux, "a+") do io
                write(io, " Zzzz")
                seekstart(io)
                @test read(io, String) == "Goodnight! Zzzz"
            end
        end
    end
end

function TestPaths.test_mkdir(ps::PathSet)
    @testset "mkdir" begin
        garply = ps.root / "corge" / "grault" / "garply"
        @test_throws ErrorException mkdir(garply)
        @test mkdir(garply; recursive=true) == garply
        @test exists(garply)
        @test_throws ErrorException mkdir(garply; recursive=true)
        @test mkdir(garply; recursive=true, exist_ok=true) == garply
        rm(ps.root / "corge"; recursive=true)
        @test !exists(garply)
    end
end

function TestPaths.test_cp(ps::PathSet)
    @testset "cp" begin
        cp(ps.foo, ps.qux / "foo"; force=true)
        @test exists(ps.qux / "foo" / "baz.txt")
        @test_throws ArgumentError cp(ps.foo, ps.qux / "foo")
        cp(ps.foo, ps.qux / "foo"; force=true)
        rm(ps.qux / "foo"; recursive=true)

        @testset "non-existent destination parent" begin
            # Test consistency with `cp` (e.g., destination parent must exist)
            dest = ps.root / "non-existent" / "destination"

            # The base behaviour can only be tested on system paths.
            if isa(dest, SystemPath)
                if VERSION >= v"1.2"    # Error type changed in Julia 1.2
                    @test_throws ProcessFailedException run(`cp -r $(ps.foo) $dest`)
                else
                    @test_throws ErrorException run(`cp -r $(ps.foo) $dest`)
                end

                if VERSION >= v"1.4"
                    @test_throws Base.IOError cp(string(ps.foo), string(dest))
                else
                    @test_throws SystemError cp(string(ps.foo), string(dest))
                end
            end

            # TODO: Use a more specific error type
            @test_throws ErrorException cp(ps.foo, dest)
        end
    end
end

function TestPaths.test_mv(ps::PathSet)
    @testset "mv" begin
        garply = ps.root / "corge" / "grault" / "garply"
        mkdir(garply; recursive=true, exist_ok=true)
        @test exists(garply)
        mv(ps.root / "corge", ps.foo / "corge"; force=true)
        @test exists(ps.foo / "corge" / "grault" / "garply")
        rm(ps.foo / "corge"; recursive=true)
    end
end

function TestPaths.test_sync(ps::PathSet)
    @testset "sync" begin
        @testset "empty destination" begin
            sync(ps.foo, ps.qux / "foo")
            @test exists(ps.qux / "foo" / "baz.txt")

            # Test that the copied baz file has a newer modified time
            baz_t = modified(ps.qux / "foo" / "baz.txt")
            @test modified(ps.baz) < baz_t
        end

        @testset "empty source" begin
            @test_throws ArgumentError sync(ps.root / "quux", ps.foo)
        end

        @testset "new source" begin
            # Don't cp unchanged files when a new file is added
            # NOTE: sleep before we make a new file, so it's clear that the
            # modified time has changed.
            baz_t = modified(ps.qux / "foo" / "baz.txt")
            sleep(1)
            write(ps.foo / "test.txt", "New src")
            sync(ps.foo, ps.qux / "foo")
            @test exists(ps.qux / "foo" / "test.txt")
            @test read(ps.qux / "foo" / "test.txt", String) == "New src"
            @test modified(ps.qux / "foo" / "baz.txt") == baz_t
            @test modified(ps.qux / "foo" / "test.txt") > baz_t
        end

        @testset "new destination" begin
            # Newer file of the same size is likely the result of an upload which
            # will always have a newer last modified time.
            test_t = modified(ps.foo / "test.txt")
            sleep(1)
            write(ps.qux / "foo" / "test.txt", "New dst")
            @test modified(ps.qux / "foo" / "test.txt") > test_t
            sync(ps.foo, ps.qux / "foo")
            @test read(ps.qux / "foo" / "test.txt", String) == "New dst"
            @test modified(ps.qux / "foo" / "test.txt") > test_t
        end

        @testset "no delete" begin
            # Test not deleting a file on sync
            rm(ps.foo / "test.txt")
            sync(ps.foo, ps.qux / "foo")
            @test exists(ps.qux / "foo" / "test.txt")
        end

        @testset "delete" begin
            # Test passing delete flag
            sync(ps.foo, ps.qux / "foo"; delete=true)
            @test !exists(ps.qux / "foo" / "test.txt")
            rm(ps.qux / "foo"; recursive=true)
        end

        @testset "mixed types" begin
            @testset "directory -> file" begin
                @test_throws ArgumentError sync(ps.foo, ps.quux)
            end

            @testset "file -> directory" begin
                @test_throws ArgumentError sync(ps.quux, ps.foo)
            end
        end

        @testset "walkpath order" begin
            # Test a condtion where the index could reorder the walkpath order.
            tmp_src = ps.root / "tmp-src"
            mkdir(tmp_src)
            src_file = tmp_src / "file1"
            write(src_file, "Hello World!")

            src_folder = tmp_src / "folder1"
            mkdir(src_folder)
            src_folder_file = src_folder / "file2"
            write(src_folder_file, "") # empty file

            src_folder2 = src_folder / "folder2"  # nested folders
            mkdir(src_folder2)
            src_folder2_file = src_folder2 / "file3"
            write(src_folder2_file, "Test")

            tmp_dst = ps.root / "tmp_dst"
            mkdir(tmp_dst)
            sync(tmp_src, tmp_dst)
            @test exists(tmp_dst / "folder1" / "folder2" / "file3")
            rm(tmp_src; recursive=true)
            rm(tmp_dst; recursive=true)
        end

        @testset "non-existent destination parent" begin
            # Test consistency with `cp` (e.g., destination parent must exist)
            # See full `cp` comparison tests above
            dest = ps.root / "non-existent" / "destination"

            # TODO: Use a more specific error type
            @test_throws ErrorException sync(ps.foo, dest)
        end
    end
end

function TestPaths.test_symlink(ps::PathSet)
    if ps.link
        @testset "symlink" begin
            @test_throws ErrorException symlink(ps.foo, ps.plugh)
            symlink(ps.foo, ps.plugh; exist_ok=true, overwrite=true)
            symlink(ps.foo, ps.plugh; exist_ok=true)
            @test_throws ErrorException symlink(
                ps.foo / "thud", ps.plugh; exist_ok=true, overwrite=true
            )
        end
    end
end

function TestPaths.test_touch(ps::PathSet)
    @testset "touch" begin
        newfile = ps.root / "newfile"
        touch(newfile)
        @test exists(newfile)
        @test ispath(newfile)
        rm(newfile)
    end
end

function TestPaths.test_tmpname(ps::PathSet)
    @testset "tmpname" begin
        @test isa(tmpname(), AbstractPath)
        @test hasparent(tmpname())
        @test exists(parent(tmpname()))
    end
end

function TestPaths.test_tmpdir(ps::PathSet)
    @testset "tmpname" begin
        @test isa(tmpdir(), AbstractPath)
        @test exists(tmpdir())
        @test isdir(tmpdir())
    end
end

function TestPaths.test_mktmp(ps::PathSet)
    @testset "mktmp" begin
        mktmp(ps.root) do path, io
            @test exists(path)
            @test iswritable(io)
            write(io, "Foobar")
            seekstart(io)
            @test read(io, String) == "Foobar"
        end
    end
end

function TestPaths.test_mktmpdir(ps::PathSet)
    @testset "mktmpdir" begin
        mktmpdir(ps.root) do path
            @test exists(path)
            write(path / "test.txt", "Foobar")
            @test read(path / "test.txt", String) == "Foobar"
        end
    end
end

function TestPaths.test_chown(ps::PathSet)
    @testset "chown" begin
        newfile = ps.root / "newfile"
        touch(newfile)

        if haskey(ENV, "USER")
            if ENV["USER"] == "root"
                chown(newfile, "nobody", "nogroup"; recursive=true)
            elseif VERSION >= v"1.2"    # Error type changed in Julia 1.2
                @test_throws ProcessFailedException chown(
                    newfile, "nobody", "nogroup"; recursive=true
                )
            else
                @test_throws ErrorException chown(
                    newfile, "nobody", "nogroup"; recursive=true
                )
            end
        end

        rm(newfile)
    end
end

function TestPaths.test_chmod(ps::PathSet)
    @testset "chmod" begin
        newfile = ps.root / "newfile"
        newpath = ps.root / "thud"

        touch(newfile)
        mkdir(newpath)
        chmod(newfile; user=(READ + WRITE + EXEC), group=(READ + EXEC), other=READ)
        @test string(mode(newfile)) == "-rwxr-xr--"
        @test isexecutable(newfile)
        @test iswritable(newfile)
        @test isreadable(newfile)

        chmod(newfile, "-x")
        @test !isexecutable(newfile)

        @test string(mode(newfile)) == "-rw-r--r--"
        chmod(newfile, "+x")
        write(newfile, "foobar")
        @test read(newfile, String) == "foobar"
        chmod(newfile, "u=rwx")

        open(newfile, "r") do io
            @test read(io, String) == "foobar"
        end

        chmod(newpath, mode(newfile); recursive=true)
    end
end

function TestPaths.test_download(ps::PathSet)
    @testset "download" begin
        rm(ps.foo / "README.md"; force=true)
        download(
            "https://github.com/rofinn/FilePathsBase.jl/blob/master/README.md",
            ps.foo / "README.md",
        )
        @test exists(ps.foo / "README.md")

        # Test downloading from another path
        download(ps.foo / "README.md", ps.qux / "README.md")
        @test exists(ps.qux / "README.md")

        # Test downloading to a string
        download(ps.foo / "README.md", string(ps.fred / "README.md"))
        @test exists(ps.fred / "README.md")
        rm.([ps.foo / "README.md", ps.qux / "README.md", ps.fred / "README.md"])
    end
end

function TestPaths.test_include(ps::PathSet)
    @testset "include" begin
        write(ps.quux, "2 + 2\n")
        res = include(ps.quux)
        @test res == 4
    end
end
end

# FAQ

Here we have a growing list of common technical and design questions folks have raised in the past.
If you feel like something is missing, please open an issue or pull request to add it.

**Q. Should I depend on FilePathsBase.jl and FilePaths.jl?**

A. FilePathsBase.jl is a lightweight dependency for packages who need to operate on `AbstractPath` types and don't need to interact with other packages (e.g., Glob.jl, URIParser.jl, FileIO.jl).
FilePaths.jl extends FilePathsBase.jl to improve package interop across the Julia ecosystem, at the cost of extra dependencies.
In general, FilePathsBase.jl should be used for general (low level) packages. While scripts and application-level packages should use FilePaths.jl.

**Q. What's wrong with strings?**

A. In many cases, nothing.
For local filesystem paths, there's often no functional difference between using an `AbstractPath` and a `String`.
Some cases where the path type distinction is useful include:

- Path specific operations (e.g., `join`, `/`, `==`)
- Dispatch on paths vs strings (e.g., `project(name::String) = project(DEFAULT_ROOT / name)`)

See [design section](@ref design_header) for more details on the advantages of path types over strings.

**Q. Why is `AbstractPath` not a subtype of `AbstractString`?**

A. Initially, we made `AbstractPath` a subtype of `AbstractString`, but falling back to string operations often didn't make sense (e.g., `ascii(::AbstractPath)`, `chomp(::AbstractPath)`, `match(::Regex, ::AbstractPath)`, `parse(::Type{Float64}, ::AbstractPath)`).
Having a distinct path type results in fewer confusing error messages and more explicit code (via type conversions). See [issue #15](https://github.com/rofinn/FilePathsBase.jl/issues/15) for more info on why we dropped string subtyping.

**Q. Why don't you concatenate paths with `*`?**

A. By using `/` for path concatenation (`joinpath`), we can continue to support string concatenation with `*`:

```julia
julia> cwd() / "src" / "FilePathsBase" * ".jl"
p"/Users/rory/repos/FilePathsBase.jl/src/FilePathsBase.jl
```

**Q. How do I write code that works with strings and paths?**

A. FilePathsBase.jl intentionally provides aliases for `Base.Filesystem` functions, so you can perform base filesystem operations on strings and paths interchangeable.
If something is missing please open an issue or pull request.
Here are some more concrete tips to help you write generic code:
- Don't [overly constrain](https://white.ucc.asn.au/2020/04/19/Julia-Antipatterns.html#over-constraining-argument-types) your argument types.
- Avoid manual string manipulations (e.g., `match`, `replace`).
- Stick to the overlapping base filesystem aliases (e.g., `joinpath` vs `/`, `normpath` vs `normalize`).

NOTE: The first 2 points are just general best practices independent of path types.
Unfortunately, the last point is a result of the `Base.Filesystem` API (could change if FilePathsBase.jl becomes a stdlib).

See the usage guide for examples.

**Q: FilePathsBase doesn't work with package X?**

A: In many cases, filepath types and strings are interchangable, but if a specific package constrains the argument type (e.g., `AbstractString`, `String`) then you'll get a `MethodError`.
There are a few solutions to this problem.

1. Loosen the argument type constraint in the given package.
2. Add a separate dispatch for `AbstractPath` and add a dependency on FilePathsBase.jl.
3. For very general/lightweight packages we can add the dependency to FilePaths.jl and extend the offending function there.
4. Manually convert your path to a string before calling into the package.
You may need to parse any returned paths to back to a filepath type if necessary.

NOTE: For larger packages, FilePaths.jl provides an `@convert` macro which will handle generating appropriate conversion methods for you.

# [Design](@id design_header)

FilePaths.jl and FilePathsBase.jl have gone through several design iterations over the years.
To help get potential contributors up-to-speed, we'll cover several background points and design choices.
Whenever possible, we'll reference existing resources (e.g., GitHub issues, blog posts, documentation, software packages) for further reading.

## Filesystem Abstractions

While filesystems themselves are abstractions for data storage, many programming languages
provide APIs for writing generic/cross-platform software.
Typically, these abstractions can be broken down into string or typed based solutions.

### String APIs:

- Python: [`os.path`](https://docs.python.org/3.8/library/os.path.html)
- Haskell: [`System.FilePath`](https://hackage.haskell.org/package/filepath-1.4.2.1/docs/System-FilePath.html)
- Julia: [`Base.Filesystem`](https://docs.julialang.org/en/v1/base/file/)

This approach tends to be simpler and only requires adding utility methods for interacting with filesystems. Unfortunately, any operations require significant string manipulation to work, and it often cannot be extended for remote filesystems (e.g., S3, FTP, HTTP). Enforcing path validity becomes difficult when any string operation can be applied to the path type (e.g., `join(prefix, segments...)` vs `joinpath(prefix, segments...)`).

### Typed APIs:

- Python: [`pathlib`](https://docs.python.org/3/library/pathlib.html)
- Rust: [`std::path`](https://doc.rust-lang.org/std/path/index.html)
- C++: [`std::filesystem`](https://en.cppreference.com/w/cpp/filesystem/path)
- Haskell: [`path`](https://hackage.haskell.org/package/path)
- Scala: [`os-lib`](https://github.com/lihaoyi/os-lib)

The primary idea is that a filesystem path is just a sequence of path segments, and so very few path operations overlap with string operations.
For example, you're unlikely to call string functions like `join(...)`, `chomp(...)`, `eachline(...)`, `match(regex, ...)` or `parse(Float64, ...)` with a filesystem path.
Further, differentiating strings and paths allows us to define different equality rules and dispatch behaviour on filepaths in our APIs.
Finally, by defining a common API for all `AbstractPaths`, we can write generic functions that work with `PosixPath`s, `WindowsPath`s, `S3Path`s, `FTPPath`s, etc.

## Path Types

In FilePathsBase.jl, file paths are first and foremost a type that wraps a tuple of strings, representing path `segments`.
Most path types will also include a `root`, `drive` and `separator`.
Concrete path types should either directly subtype `AbstractPath` or in the case of local filesystems (e.g., `PosixPath`, `WindowsPath`) from `SystemPath`, as shown in the diagram below.

![Hierarchy](hierarchy.svg)

Notice that our `AbstractPath` type no longer subtypes `AbstractString` like some other libraries.
We [chose](https://github.com/rofinn/FilePathsBase.jl/issues/15) drop string subtyping because not all `AbstractString` operations make sense on paths, and even more seem like they should perform a fundamentally different operation as mentioned above.
Similar points have been made for [why `pathlib.Path` doesn't inherit from `str` in Python](https://snarky.ca/why-pathlib-path-doesn-t-inherit-from-str/).

# API

To compare and contrast `FilePathsBase` with `Base.Filesystem` we provide tables for common operations.
Use `?` at the REPL to get the documentation and arguments as they may be different than the base implementations.

## Operations

A table of common operations with Filesystem and FilePathsBase.

Filesystem | FilePathsBase.jl
--- | ---
"/home/user/docs" | p"/home/user/docs"
N/A | Path()
pwd() | pwd(SystemPath) or cwd()
homedir() | homedir(SystemPath) or home()
cd() | cd()
joinpath() | /
basename() | basename()
N/A | hasparent, parents, parent
splitext | splitext
N/A | filename
N/A | extension
N/A | extensions
ispath | exists
realpath | canonicalize
normpath | normalize
abspath | absolute
relpath | relative
stat | stat
lstat | lstat
filemode | mode
filesize | filesize
mtime | modified
ctime | created
isdir | isdir
isfile | isfile
islink | islink
issocket | issocket
isfifo | isfifo
ischardev | ischardev
isblockdev | isblockdev
isexecutable (deprecated) | isexecutable
iswritable (deprecated) | iswritable
isreadable (deprecated) | isreadable
ismount | ismount
isabspath | isabsolute
splitdrive()[1] | drive
N/A | root (property)
split(p, "/") | segments (property)
expanduser | expanduser
mkdir | mkdir
mkpath | N/A (use mkdir)
symlink | symlink
cp | cp
mv | mv
download | download
readdir | readdir
N/A | readpath
walkpath | walkpath
rm | rm
touch | touch
tempname() | tempname(::Type{<:AbstractPath}) (or tmpname)
tempdir() | tempdir(::Type{<:AbstractPath}) (or tmpdir)
mktemp() | mktemp(::Type{<:AbstractPath}) (or mktmp)
mktempdir() | mktempdir(::Type{<:AbstractPath}) (or mktmpdir)
chmod | chmod (recursive unix-only)
chown (unix only) | chown (unix only)
read | read
write | write
@__DIR__ | @__PATH__
@__FILE__ | @__FILEPATH__

## Aliases

A slightly reduced list of operations/aliases that will work with both strings and path types.
The `Filesystem` and `FilePathsBase` columns indicate what type will be returned from each
each library. As you'd expect, most return types match the input argument(s).

Function Name | Filesystem | FilePathsBase
--- | --- | ---
cd | AbstractString | AbstractPath
joinpath | AbstractString | AbstractPath
basename | AbstractString | AbstractString
splitext | (AbstractString, AbstractString) | (AbstractPath, AbstractString)
ispath | Bool | Bool
realpath | AbstractString | AbstractPath
normpath | AbstractString | AbstractPath
abspath | AbstractString | AbstractPath
relpath | AbstractString | AbstractPath
stat | StatStruct | FilePathsBase.Status
lstat | StatStruct | FilePathsBase.Status
filemode | UInt64 | FilePathsBase.Mode
filesize | Int64 | Int64
mtime | Float64 | Float64
ctime | Float64 | Float64
isdir | Bool | Bool
isfile | Bool | Bool
islink | Bool | Bool
issocket | Bool | Bool
isfifo | Bool | Bool
ischardev | Bool | Bool
isblockdev | Bool | Bool
ismount | Bool | Bool
isabspath | Bool | Bool
expanduser | AbstractString | AbstractPath
mkdir | AbstractString | AbstractPath
mkpath | AbstractString | AbstractPath
symlink | Nothing | Nothing
cp | AbstractString | AbstractPath
mv | AbstractString | AbstractPath
download | AbstractString | AbstractPath
readdir | AbstractString | AbstractString
rm | Nothing | Nothing
touch | AbstractString | AbstractPath
chmod | AbstractString | AbstractPath
chown | AbstractString | AbstractPath
read(fp, T) | T | T
write | Int64 | Int64


```@meta
DocTestSetup = quote
    using FilePathsBase
    using FilePathsBase: /
end
```

```@docs
FilePathsBase.AbstractPath
FilePathsBase.Path
FilePathsBase.SystemPath
FilePathsBase.PosixPath
FilePathsBase.WindowsPath
FilePathsBase.Mode
FilePathsBase.@p_str
FilePathsBase.@__PATH__
FilePathsBase.@__FILEPATH__
FilePathsBase.@LOCAL
FilePathsBase.cwd
FilePathsBase.home
FilePathsBase.hasparent
FilePathsBase.parents
FilePathsBase.parent
Base.:(*)(::P, ::Union{P, AbstractString, Char}...) where P <: AbstractPath
FilePathsBase.:(/)(::AbstractPath, ::Union{AbstractPath, AbstractString}...)
FilePathsBase.join(::T, ::Union{AbstractPath, AbstractString}...) where T <: AbstractPath
FilePathsBase.filename(::AbstractPath)
FilePathsBase.extension(::AbstractPath)
FilePathsBase.extensions(::AbstractPath)
Base.isempty(::AbstractPath)
normalize(::T) where {T <: AbstractPath}
absolute(::AbstractPath)
FilePathsBase.isabsolute(::AbstractPath)
FilePathsBase.relative(::T, ::T) where {T <: AbstractPath}
Base.readlink(::AbstractPath)
FilePathsBase.canonicalize(::AbstractPath)
FilePathsBase.mode(::AbstractPath)
FilePathsBase.modified(::AbstractPath)
FilePathsBase.created(::AbstractPath)
FilePathsBase.isexecutable
Base.iswritable(::PosixPath)
Base.isreadable(::PosixPath)
Base.cp(::AbstractPath, ::AbstractPath)
Base.mv(::AbstractPath, ::AbstractPath)
Base.download(::AbstractString, ::AbstractPath)
FilePathsBase.readpath
FilePathsBase.walkpath
FilePathsBase.diskusage
Base.open(::AbstractPath)
FilePathsBase.tmpname
FilePathsBase.tmpdir
FilePathsBase.mktmp
FilePathsBase.mktmpdir
Base.chown(::PosixPath, ::AbstractString, ::AbstractString)
Base.chmod(::PosixPath, ::Mode)
FilePathsBase.TestPaths
FilePathsBase.TestPaths.PathSet
```
